<?php
class get_constants extends DOMDocument {
	var $view = false;
	function action($idlist) {
                libxml_clear_errors ();
		$encription_lib_pars = array();
		$encription_lib_pars['show_msg'] = '0';

		$session = Validate::regular_session ();
		if ($session) {
			return $session;
		}
		
		$path = $idlist->getREQUEST ( 'path' );
		$path = substr ( $path, - ((strlen ( $path ) - strpos ( $path, ";" )) - 1) );
		
		if (($version = $idlist->getREQUEST ( 'version' )) == true) {
			$version = preg_replace ( '% %', kDateFormatChar1, $version );
			$version = preg_replace ( '%:%', kDateFormatChar2, $version );
			$version = preg_replace ( '%-%', kDateFormatChar3, $version );
			$filename = kConstants . kDateFormatChar . $version . kConstantsExt;
		} else {
			$filename = kConstants . kConstantsExt;
		}
		
		if (file_exists ( kPathToRoot . $path . $filename )) {
			libxml_use_internal_errors ( true );
			$doc = new DOMDocument ();
			$file = kPathToRoot . $path . $filename;
			
			if (! $doc->load ( $file )) {
				$filecontent = file ( $file );

//				$DoDecrypt = new Encription ();
				$DoDecrypt = new Encription ($encription_lib_pars);
				$filedoc = $DoDecrypt->start ( "DoDecrypt", $filecontent [0] );
				$msg = $DoDecrypt->getLastErrCode();
				if($msg !== '') {
					$msg = $DoDecrypt->getLastErrMsg() . ' [' . $msg . ']';
					$result = new Response ('amb_view', $msg, true);
					return $result->getXml ();
				}
				
				$doc->loadXML ( $filedoc );
				return $doc->saveXml ();
				
				libxml_clear_errors ();
			} else {
				$filecontent = file ( kPathToRoot . $path . kConstants . kConstantsExt );
				//$docEncrypt = new Encription ();
				$docEncrypt = new Encription ($encription_lib_pars);
				$document = $docEncrypt->start ( "DoEncrypt", $filecontent [1] );
				$msg = $docEncrypt->getLastErrCode();
				if($msg !== '') {
					$msg = $docEncrypt->getLastErrMsg() . ' [' . $msg . ']';
					$result = new Response ('amb_view', $msg, true);
					return $result->getXml ();
				}
				
				$handle = fopen ( kPathToRoot . $path . kConstants . kConstantsExt, "w" );
				fwrite ( $handle, $document );
				
				if (file_exists ( kPathToRoot . $path . $filename )) {
					$filecontent = file ( $file );
					$filedoc = $docEncrypt->start ( "DoDecrypt", $filecontent [0] );
					$msg = $docEncrypt->getLastErrCode();
					if($msg !== '') {
						$msg = $docEncrypt->getLastErrMsg() . ' [' . $msg . ']';
						$result = new Response ('amb_view', $msg, true);
						return $result->getXml ();
					}
					$doc->loadXML ( $filedoc );
					return $doc->saveXml ();
				}
				
				$result = new Response ( 'amb_view', 21 );
				return $result->getXml ();
			}
		} else {
			$doc = new DOMDocument ( "1.0" );
			$root = $doc->createElement ( 'ok' );
			$root = $doc->appendChild ( $root );
			return $doc->saveXml ();
		}
	}
}

?>