
// Ajax related functions.
function getXml(type,adress,data,dataT,func){
	ajaxErrorClear()
	$('#loading').show('fast');
	$.ajax({
		type : type,
		url : adress,
		dataType : dataT,
		data : data,
		error : ajaxError,
		success : func
	});	
	$(document).ajaxStop(function(){$('#loading').hide('fast');});
}
var x;
function ajaxError(obj){x=obj;
	$('#msg').show();
	$(".error_msg").replaceWith(
//			createDiv("error_msg","<center><b>Ajax Error</b> <input type='image' height='20' width='20' src='./images/icons/REload.png' onclick='location.reload();'></center>"));
			createDiv("error_msg","<center><b>Ajax Error</b> <input type='image' height='20' width='20' src='./images/icons/REload.png' onclick='location.reload();'><br>"+obj.response+"<br></center>"));
}
function ajaxErrorClear(){
	$(".error_msg").replaceWith(createDiv("error_msg", ''));
	$('#msg').hide();
}

function prepare(form, func) {
	if (func != '') {
		var tmp = func();
		if (!tmp) {
			return false;
		}
	}
	$(document).ready(function() {
		$('#' + form).ajaxForm(function() {
		});
	});
	
}

// Pre reset function for conf forms
function preReset(){
	$('input.array:hidden').each(function(){
		var name =  $(this).attr("id");
		var min = parseInt(this.defaultValue);
		var max = parseInt(this.value);	
		
		for(var i = min; i < max; i++){
			remove(name,min);
		}		
	});	
	return false;
}



// Password related function... if you're wondering about the name, play Crysis
function maximumStrength(){
	var text = new Array(); 
	text[0] = $("#pass_strength_too_weak").html();
	text[1] = $("#pass_strength_weak").html();
	text[2] = $("#pass_strength_normal").html();
	text[3] = $("#pass_strength_strong").html();
	text[4] = $("#pass_strength_very_strong").html();
	$('#password').password_strength({container : password_str, texts : text});
}

// creates and destroys div in array type for the configurator.
function generateFirst(id, main) {
	var num = 0;
	var str = document.getElementById(id).innerHTML;
	str = str.replace(/%num%/g, num);
	var text = "<div class='" + main + num + "'>";
	text += str + "</div>";
	$("." + main).append(text);
}

function generate(id, main) {
	var num = parseInt(getValue(main));
	var str = document.getElementById(id).innerHTML;
	str = str.replace(/%num%/g, num);
	var text = "<div class='" + main + num + "'>";
	text += str + "</div>";
	$("." + main).append(text);
	setValue(main, num + 1);
}

function remove(main,min) {
	var num = parseInt(getValue(main));
	if (num > min) {
		num--;
		$("." + main + num).remove();
		setValue(main, num);
	}
}

// Xml related functions
function sendData(adress, form) {	
	var datos = $('#' + form).formSerialize();
	getXml("POST",adress,datos,'xml',parseXml);
}

function parseXml(xml) {
	lang = $(xml).find("lang").text();
	
	if ($(xml).find("sidebar").text() != '') {
		$(".sidebar").replaceWith(
				createDiv('sidebar', $(xml).find("sidebar").text()));
	}

	if ($(xml).find("main_menu").text() != '') {
		$(".main_menu").replaceWith(
				createDiv("main_menu", $(xml).find("main_menu").text()));
	}
	
	$(".js").replaceWith(
			createDiv("js", createScript($(xml).find("js").text())));
	
	if($(xml).find("error_type").text()!= ''){
		var type = $(xml).find("error_type").text();
		var color = '';		
		switch(type){
			case 'error':
				color = 'red';
				break;
			case 'success':
				color = 'green';
				break;
			default:
				color = 'black';
				break;
		}
	}	
	
	if($(xml).find("error_msg").text()!= ''){
		$('#msg').show();
		$(".error_msg").replaceWith(
			createDiv("error_msg", colorFont($(xml).find("error_msg").text(),color)));	
	}else{
		$('#msg').hide();
	}

	if (window.DOMParser){
		dict = $(xml).find("dict").text();
		
		$('table.round').corner("5px");
		$('td.rounder').corner("5px");
		$('td.round').corner("5px");		
	}else{
		dict=new ActiveXObject("Microsoft.XMLDOM");
		dict.async="false";
		dict.loadXML($(xml).find("dict").text()); 
		
		$('td.rounder').corner("5px");
	}
	translate(dict,lang);
}

function colorFont(text,color){
	return "<b><font color="+color+">"+text+"</font></b>";
}

// automatic try catch because i'm lazy
function quiet(func){
	try{
		func();
	}catch(err){
		/* alert(err + " " + func); */
	}	
	return '';
}

// Form value functions

function isEmpty(camp) {
	var campo = document.getElementById(camp).value; 
	if (campo == "" || campo == null) return true;
	return false;
}

function same(camp1,camp2){
	var campo1 = document.getElementById(camp1).value; 
	var campo2 = document.getElementById(camp2).value; 
	
	if(campo1 == campo2){
		return true;
	}else{
		return false;
	}	
}

// getters and setters
function getValue(id) {
	return document.getElementById(id).value;
}

function setValue(id,value){
	return $("#"+id).val(value);
}

// Html help functions
function createDiv(divClass, divText) {
	return '<div class = "' + divClass + '">' + divText + '</div>';
}

function createScript(text) {
	return '<script language="JavaScript" type="text/javascript">' + text
			+ '</script>';
}

function createScriptID(text,id) {
	return '<script id="' + id + '" language="JavaScript" type="text/javascript">' + text
			+ '</script>';
}

function createOption(value, option, selected) {
	if(selected){
		return '<option value = "' + value + '" selected="selected">' + option + '</option>';
	}else{
		return '<option value = "' + value + '">' + option + '</option>';
	}
}

function createOptionId(value, option, selected, id) {
	if(selected){
		return '<option id="'+id+'" value = "' + value + '" selected="selected">' + option + '</option>';
	}else{
		return '<option id="'+id+'" value = "' + value + '">' + option + '</option>';
	}
}

function createTab(name){
	return "<li><a href=#"+name+" class='"+name+"_name'></a></li>";
}

function createCont(name,text){
	return "<div id="+name+"><table>"+text+"</table></div>";
}

function createOpt(type,def,opt,id,num){	
	var obl = 'notObl';
	var fontColor = "#222222";
	if(opt == 'false'){
		obl = 'obl';
		fontColor = "#ff0000";
	}
	
	if(type == 'String' || type == 'Path'){
		return "<tr><td align='right'><label><font title='"+id.text()+"' color='"+fontColor+"' class='"+id.text()+"_name "+id.text()+"_tooltip "+id.text()+num+"_id'></font></label></td><td><input type='text' name='"+id.text()+num+"' id='"+id.text()+num+"' class = '"+obl+"' value='"+def+"' size='40'></td><td><img class='"+id.text()+"_tooltip' src='./images/icons/question-mark.png' height='25' width='25'/></td><tr>";
	}
	
	if(type == 'int' || type == 'StringInt'){
		return "<tr><td align='right'><label><font title='"+id.text()+"' color='"+fontColor+"' class='"+id.text()+"_name "+id.text()+"_tooltip "+id.text()+num+"_id'></font></label></td><td><input type='text' name='"+id.text()+num+"' id='"+id.text()+num+"' value='"+def+"' class='number "+obl+"' size='34'></td><td><img class='"+id.text()+"_tooltip' src='./images/icons/question-mark.png' height='25' width='25'/></td><tr>";
	}
	
	if(type == 'MB'){
		return "<tr><td align='right'><label><font title='"+id.text()+"' color='"+fontColor+"' class='"+id.text()+"_name "+id.text()+"_tooltip "+id.text()+num+"_id''></font></label></td><td><input type='text' name='"+id.text()+num+"' id='"+id.text()+num+"' value='"+def+"' class='megabyte "+obl+"' size='31'></td><td><img class='"+id.text()+"_tooltip' src='./images/icons/question-mark.png' height='25' width='25'/></td><tr>";
	}
	
	if(type == 'negMB'){
		return "<tr><td align='right'><label><font title='"+id.text()+"' color='"+fontColor+"' class='"+id.text()+"_name "+id.text()+"_tooltip "+id.text()+num+"_id''></font></label></td><td><input type='text' name='"+id.text()+num+"' id='"+id.text()+num+"' value='"+def+"' class='negmb "+obl+"' size='31'></td><td><img class='"+id.text()+"_tooltip' src='./images/icons/question-mark.png' height='25' width='25'/></td><tr>";
	}
	
	if(type == 'Port'){
		return "<tr><td align='right'><label><font title='"+id.text()+"' color='"+fontColor+"' class='"+id.text()+"_name "+id.text()+"_tooltip "+id.text()+num+"_id'></font></label></td><td><input type='text' name='"+id.text()+num+"' id='"+id.text()+num+"' value='"+def+"' class='port "+obl+"' size='34'></td><td><img class='"+id.text()+"_tooltip' src='./images/icons/question-mark.png' height='25' width='25'/></td><tr>";
	}
	
	if(type == 'password'){
		return "<tr><td align='right'><label><font title='"+id.text()+"' color='"+fontColor+"' class='"+id.text()+"_name "+id.text()+"_tooltip "+id.text()+num+"_id''></font></label></td><td><input type='password' name='"+id.text()+num+"' id='"+id.text()+num+"' class = '"+obl+"' value='"+def+"' size='40'></td><td><img class='"+id.text()+"_tooltip' src='./images/icons/question-mark.png' height='25' width='25'/></td><tr>";
	}
	
	if(type == 'Boolean' || type=='intBoolean'){
		if(def == 'true'){
			return "<tr><td align='right'><label><font title='"+id.text()+"' class='"+id.text()+"_name "+id.text()+"_tooltip "+id.text()+num+"_id'></font></label></td><td><input type='checkbox' name='"+id.text()+num+"' id='"+id.text()+num+"' checked='checked' size='20'></td><td><img class='"+id.text()+"_tooltip' src='./images/icons/question-mark.png' height='25' width='25'/></td><tr>";
		}else{
			return "<tr><td align='right'><label><font title='"+id.text()+"' class='"+id.text()+"_name "+id.text()+"_tooltip "+id.text()+num+"_id'></font></b></label></td><td><input type='checkbox' name='"+id.text()+num+"' id='"+id.text()+num+"' size='20'></td><td><img class='"+id.text()+"_tooltip' src='./images/icons/question-mark.png' height='25' width='25'/></td><tr>";
		}		
	}
	
	if(type == 'date'){		
		return "<tr><td align='right'><label><font title='"+id.text()+"' color='"+fontColor+"' class='"+id.text()+"_name "+id.text()+"_tooltip "+id.text()+num+"_id'></font></label></td><td><input type='text' class='datepicker "+obl+"' name='"+id.text()+num+"' id='"+id.text()+num+"' value='"+def+"' size='40'></td><td><img class='"+id.text()+"_tooltip' src='./images/icons/question-mark.png' height='25' width='25'/></td><tr>";
	}

	if(type == 'radio'){
		return "<tr><td align='right'><label><font title='"+id.text()+"' class='"+id.text()+"_name "+id.text()+"_tooltip "+id.text()+num+"_id'></font></label></td><td><input type='radio' name='"+id.text()+"' id='"+id.text()+num+"' value='"+num+"'/></td><td><img class='"+id.text()+"_tooltip' src='./images/icons/question-mark.png' height='25' width='25'/></td><tr>";
	}
	
	if(type == 'option'){
		var text = '';
		var name = '';
		
		id.find("name").each(function(){	
			name = $(this).text();
			text += "<tr><td align='right'><label><font title='"+name+"' color='"+fontColor+"' class='"+$(this).text()+"_name "+$(this).text()+"_tooltip "+$(this).text()+num+"_id'></font></label></td><td><select class='"+$(this).text()+num+" "+obl+"' id='"+$(this).text()+num+"' name='"+$(this).text()+num+"'>";
		});	
		
		id.find("value").each(function(){	
			if(def == $(this).text()){
				text+= createOption($(this).text(),$(this).attr("name"),true);
			}else{
				text+= createOption($(this).text(),$(this).attr("name"),false);	
			}
		});	
		
		text+= "</select></td><td><img class='"+name+"_tooltip' src='./images/icons/question-mark.png' height='25' width='25'/></td><tr>";
		return text;
	}
	
	if(type == 'array'){
		var min = 0;
		if(opt == 'false'){
			min = 1;
		}
		
		var text = "<tr><td colspan='3'><fieldset>";
				
		var name = '';		
		id.find("title").each(function(){		
			name = $(this).text();
			text += "<legend><font title='"+$(this).text()+"' class='"+$(this).text()+"_name "+$(this).text()+"_tooltip "+$(this).text()+num+"_id'></font></legend>";
			text += "<div style='display: none;'><input type='text' class='array' id='"+$(this).text()+num+"'name='"+$(this).text()+num+"' value='"+min+"'/></div>";
		});		
		
		text += "<div class='"+name+num+"'>";
		
		var form = "";
		id.find("atribute").each(function(){
			var type = $(this).attr("type");
			var def  = $(this).attr("default");
			var opt  = $(this).attr("optional");
			var id = $(this);
			form += createOpt(type,def,opt,id,'%num%');		
		});		
		
		if(opt == 'false'){
			script += "generateFirst(\"id_"+name+num+"\",\""+name+num+"\");";
		}
		
		text += "<div id='id_"+name+num+"' style='display: none;'><fieldset><legend><font class='"+name+"_name'></font>[%num%]</legend><table>"+form+"</table></fieldset></div>";
		text += "</div><center><input type='hidden' id='remove_"+name+num+"' value='"+min+"'><input type='button' value ='+' onclick ='generate(\"id_"+name+num+"\",\""+name+num+"\");'>";
		text += "<input type='button' value ='-' onclick ='remove(\""+name+num+"\","+min+");'></center>";
		return text+"</fieldset></td><tr>";
	}
	
	return '';
}

// Load versions of constants
function loadValues(xml) {
	var errcode = "";
	var errmsg = "";
	$(xml).find("page").each(function() {
                $(this).find("error_number").each(function() {
                    errcode = $(this).text();
                });
                $(this).find("error_msg").each(function() {
                    errmsg = $(this).text();
                });
	});
        if(errcode != "") {
            ajaxError({response : errmsg + ' - ' + errcode});
        }

	$(xml).find("constant").each(function() {
		var type = $(this).attr("type");
		var name = $(this).attr("name");
		var value = $(this).text();
		switch (type) {
		case 'Boolean':
			if (value == 'true') {
				quiet(function(){document.getElementById(name).checked = true;});
			} else {
				quiet(function(){document.getElementById(name).checked = false;});
			}
			break;
		case 'intBoolean':
			if (value == 1) {
				quiet(function(){document.getElementById(name).checked = true;});
			} else {
				quiet(function(){document.getElementById(name).checked = false;});
			}
			break;
		default:
			quiet(function(){document.getElementById(name).value = value;});
			break;
		}
	});

	$(xml).find("array").each(function() {
		var name = $(this).attr("name");
		var maxIndex = $(this).find("index").size();

		var num = parseInt(getValue(name));		
		
		if (num < maxIndex) {
			for ( var index = num; index < maxIndex; index++) {
				generate("id_" + name, name);
			}
		} else {
			for ( var index = maxIndex; index < num; index++) {
				var min = parseInt($('#remove_'+name).val());
				remove(name,min);
			}
		}
		
		$(this).find('index').each(function(){
			var index = $(this).attr('name');
			
			$(this).find("value").each(function() {
				var type = $(this).attr("type");
				var name = $(this).attr("name");
				var value = $(this).text();
				switch (type) {
				case 'radio':
					quiet(function(){document.getElementById(name+value).checked = true;});		
					break;
				case 'Boolean':
					if (value == 'true') {
						quiet(function(){document.getElementById(name+index).checked = true;});
					} else {
						quiet(function(){document.getElementById(name+index).checked = false;});
					}
					break;
				case 'intBoolean':
					if (value == '1') {
						quiet(function(){document.getElementById(name+index).checked = true;});
					} else {
						quiet(function(){document.getElementById(name+index).checked = false;});
					}
					break;
				default:
					quiet(function(){document.getElementById(name+index).value = value});
					break;
				}
			});
		});
	});	
}

function activate(){
	// Tabs
	$('#tabs').tabs();

	// Datepicker
	$('.datepicker').datepicker({
		dateFormat : 'yy-mm-dd'
	});

	// Numeric
	$('.number').numeric({
		increment : 1,
		emptyValue : false,
		minValue : 0
	});

	// Megabytes
	$('.megabyte').numeric({
		increment : 1,
		emptyValue : false,
		minValue : 0,
		showCurrency : true,
		currencySymbol : 'MB'
	});
	
	// Negative Megabytes (allows -1)
	$('.negmb').numeric({
		increment : 1,
		emptyValue : false,
		minValue : -1,
		showCurrency : true,
		currencySymbol : 'MB'
	});
	
	// Ports
	$('.port').numeric({
		increment : 1,
		emptyValue : false,
		minValue : 0,
		maxValue : 65535
	});
}