function goTo(adress,module){
	getXml("GET",adress + '?mod='+module,'','xml',parseXml);
}

function getOptions(){
	getXml("GET",adress + '?mod=get_options','','xml',orderOptions);
}

function orderOptions(xml){
	$('#name').replaceWith('<font id="name" class="name info"></font>');
	$('#version').replaceWith('<font id="version" class="version info"></font>');
	$('.options').replaceWith('<div id="accordion" class="options"></div>');
	$('#images').replaceWith("<div id='images'>&nbsp;&nbsp;&nbsp;</div>");
	
	$(xml).find("image").each(function(){
		var src = $(this).attr('src');
		var module = $(this).text();
		var id = $(this).attr('name');
		
		var text = '<a href="#"><img id="'+id+'" src="'+src+'" ';		
		text += 'onclick="goTo(adress,\''+module+'\');"';		
		text += 'width="20" height="20" /></a>&nbsp;&nbsp;&nbsp;';
		
		$("#images").append(text);
	});
	
	$(xml).find("user").each(function(){
		$(".name").append($(this).text());
	});
	
	$(xml).find("version").each(function(){
		$(".version").append($(this).text());
	});
	
	var str = '';	
	$(xml).find("options_set").each(function(){
		var name = $(this).attr("name");
		str += "<div><h3><a href='#'><b id='"+name+"' class='side_options'></b></a></h3><div align='left'>";		
		$(this).find("option").each(function(){
			var module = $(this).text();
			var option = $(this).attr("name");			
			str += '&nbsp;<a href="#" id="'+option+'" onclick="goTo(adress,\''+module+'\');">';
			str += '</a><br>';
		});
		str += "<br></div>";
	});	
	$(".options").append(str);	
	getOptionsLang();

	// Accordion
	$("#accordion").accordion({
		header : "h3"
	});	
	
}

function getOptionsLang(){
	getXml("GET",adress + '?mod=get_options_lang','','xml',translateOpt);
}

function translateOpt(xml){
	translate(xml,lang);
}

getOptions();