<?php

/**
 * File to be run by cron Scheduler Each Minute
 */
if (!defined('__DIR__')) {
    define('__DIR__', dirname(__FILE__));
}
set_include_path(str_replace('\\', DIRECTORY_SEPARATOR, __DIR__) . DIRECTORY_SEPARATOR . PATH_SEPARATOR . get_include_path());
require 'includes/constants_xpengine.php';##
//$_SESSION["maxdebug"]=4000000;$_SESSION['_dEBUG']=99;$_SESSION['dEBUG']=99;
require kPathToWebSite . '/includes/includes.php';
//$GLOBALS['ADDRDEBUGIMPORT']=1;
PrepareConstants();
ConnectToDatabase();
if (uppercase(substr(PHP_OS, 0, 3)) !== 'WIN') {
	changepermisionfiledefault();
}
initToolsCron();

$subprocess=false;
if ($argc > CLX_NUM_ONE) {
    //Running process on demand
    $PRSC = &getTool('PRSC');
	for ($t=2;$t<$argc;$t++) {
//////		echo chr(10),'argv['.$t.']  :',$argv[$t],chr(10);
		if ($argv[$t]!='-c' && substr($argv[$t],-7)!='php.ini' && $argv[$t]!='clxcron.php') {
			if ($PRSC->schedule_exists($argv[$t]) ) {
				$prmt = $PRSC->cronParseBatchArgumentParameters($argv[$t+2]);
				$PRSC->cronOnDemandRun($argv[$t], $argv[$t+1], $prmt);
				
			} else {
				print 'ERROR: Invalid Schedule: ('.$argv[$t].') / Cronograma invalido';
		
			}
			$subprocess=true;
			break;
		}	
	}	
} 

if(!$subprocess) {

    //Normal Cron execution
    $PRSC = &getTool('PRSC');#error_reporting(E_ALL);
    $PRSC->cron_welcome_sign('Auditing Process');//echo 'xx';
    $ANRJ = &getTool('ANRJ'); // 2018-12-05 CR - Caso 1003486 - GB-Rep BATCH no arranca
    $ANRJ->runCronBatch();

//	cambiaGloqIdle();//echo 'aeeq';
	$DBAU = getToolObject('UTIL', 'DBAU');//echo 'aca';
    $DBAU->runAudits();
    //Runing Batch Imports
    $PRSC->cron_welcome_sign('Batch Imports Process');
##    $DBIM = &getTool('DBIM');
##    $DBIM->import_batch_run();
	
    
    //Checking Schedules
    $PRSC->cron_welcome_sign('Schedules Process');
    $PRSC->check_schedule();
    $PRSC->cron_welcome_sign('Batch Mail Process');
    $MAIL = &getTool('MAIL');
    $MAIL->runMessageQueueCron();
    $PRSC->cron_welcome_sign('Batch Reports Process');
    $ANRJ = &getTool('ANRJ'); // 2018-12-05 CR - Caso 1003486 - GB-Rep BATCH no arranca
    $ANRJ->runCronBatch();
}
unset($PRSC, $DBIM, $DBAU);
/*function cambiaGloqIdle() {
	$sql = 'SELECT CONCAT(PROC_STATUS,CONCAT('.singleQuote(',').',BATCH_PID)) FROM  CLX_PR_SCHEDULES WHERE IDCODE='.singleQuote('GLOQ');
        $valores= ClxCommon::$db->getOne($sql);
	list($valor,$batch)=explode(",",$valores);
	if ($valor=='RUN') {
		if (!file_exists(kPathToWebSite.'/'.kPathToTemp.'gloq.txt')) {
			$tta=fopen(kPathToWebSite.'/'.kPathToTemp.'gloq.txt','w+');
			fwrite($tta,'0,'.$batch);
			fclose($tta);
		}
		else {
			$tta=fopen(kPathToWebSite."/".kPathToTemp.'gloq.txt','r');
			$xx= fread($tta,60);
			fclose($tta);
			
			list($x,$b)=explode(',',$xx);
			if ($b!=$batch) {
				$x=0;
			}
			else {
				$x++;
			}
			$tta=fopen(kPathToWebSite."/".kPathToTemp.'gloq.txt','w+');
			fwrite($tta,$x.','.$batch);
			fclose ($tta);	
			if ($x>=PRSC_RUN_END_PROCESS_IDLE) {
					$sql = 'UPDATE CLX_PR_SCHEDULES SET PROC_STATUS="IDLE" WHERE IDCODE="GLOQ"';
					$valor= ClxCommon::$db->executeQuery($sql);
			}
				
		}
	}
	else {
		$tta=fopen(kPathToWebSite."/".kPathToTemp.'gloq.txt','w+');
		fwrite($tta,'0,'.$batch);
		fclose ($tta);
	}
}*/