c<?php
/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-03 12:24:19 -0400 (Thu, 03 Sep 2015) $
 * @version        $Rev: 6814 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
/**
 * Inventory module utilities
 */

/**
 * Order total amount
 */
function & updateOrderTotal($record) {
    if (!empty($record['PO_CODE'])) {
        $result = ClxCommon::$db->executeQuery('SELECT SUM(LINE_TOTAL) ORDER_AMT, SUM(QUANTITY) ORDER_QTY  FROM PURC_ORDER_LINES  WHERE PO_CODE=' . singleQuote($record['PO_CODE']));
        $t = ClxCommon::$db->getNextRecord($result);
        if (empty($t))
		  $t = array('ORDER_AMT' => '0.00', 'ORDER_QTY' => '0.00');
		ClxCommon::$db->freeResult($results);  
        ClxCommon::$db->updateRecord('PURC_ORDERS', $t, 'IDCODE=' . singleQuote($record['PO_CODE']));
    }
}

// End function
/**
 * Order line Total Amount
 */
function & orderLineTotal($record) {
    $record['LINE_TOTAL'] = $record['QUANTITY'] * $record['PRICE'];
    return $record;
}

// End function
/**
 * Order Line Sequence Number
 */
function & orderLineSequence($record) {
    if (!empty($record['PO_CODE'])) {
        $record['SEQNUM'] = ClxCommon::$db->getOne('SELECT MAX(SEQNUM)+1 FROM PURC_ORDER_LINES WHERE PO_CODE=' . singleQuote($record['PO_CODE']));
        if (empty($record['SEQNUM']))
		  $record['SEQNUM'] = CLX_NUM_ONE;
    }
    return $record;
}

// End function
/**
 * 	Prepare Expiration Date for order line based on product longevety_days
 */
function & orderLineExpiration($record) {
    if (!empty($record['PRODUCT_CODE'])) {
        $a = ClxCommon::$db->getField('CRM_PRODUCTS', 'LONGEVETY_DAYS', 'IDCODE=' . singleQuote($record['PRODUCT_CODE']));
        if (!empty($a['LONGEVETY_DAYS'])) {
		  $record['EXPIRATION_DATE'] = adodb_date('Y-m-d', adodb_strtotime('today + ' . $a['LONGEVETY_DAYS'] . ' days'));
        }
    }
    return $record;
}

// End function
/**
 * Order Line inventory on hand and recived balance
 */
function updateInventoryQty($record) {
    $t = array();
    $t['QTY_ONHAND'] = $record['QTY_RECEIVED'];
    $t['QTY_ONORDER'] = $record['QUANTITY'];
    $t['QTY_REJECTED'] = $record['QTY_REJECTED'];
    if (!empty($record['PRODUCT_CODE'])) {
        ClxCommon::$db->updateRecord('CRM_PRODUCTS', $t, 'IDCODE=' . singleQuote($record['PRODUCT_CODE']));
    }
}

// End function
