<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: alenetdev $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-05-08 11:21:10 +0000 (Tue, 08 May 2018) $
 * @version        $Rev: 9814 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class loin_utitities {

    /**
     * Constructor
     */
    function __construct() {
        multiTableName($this, array('LILO', 'LIDS', 'LIDT', 'LIBA','LITR'));
    }


// end method
    /**
     * SRRQ Validation
     *
     * @param array $msg
     * @param array $record
     * @return boolean
     */
    
	function init_form(&$record) {
		 if ((UserRequest::$request['ac'] == 'CREATE' || UserRequest::$request['ac'] == 'DUPLICATE') && empty(UserRequest::$post['confirm'])) {
			  $record ['LITR_TRANS_STATUS']='PEND';
			  $record ['LITR_LIDS_QRYCODE']=''; 
			  $record ['LITR_REC_ID']='';
			  $record ['LITR_LIDS_QRYCODE_prim']='';
			  $record ['LITR_LIDS_QRYCODE_secd']='';
			  $record ['LITR_OBSERVATION']='';
		  }	
	      
	}
	
	function load_form(&$record) {
		if ((UserRequest::$request['ac'] == 'CREATE' || UserRequest::$request['ac'] == 'DUPLICATE') && empty(UserRequest::$post['confirm'])) {
            $this->init_form($record);
        }
    }
	
	
	
	function validateLids(&$msg, $record) {
  
    }
	
	function validateLitr(&$msg, &$record) {
  		$status = true;
		//echo UserRequest::$request['ac'] ; 
		if (UserRequest::$request['ac'] == 'CREATE' || UserRequest::$request['ac'] == 'MODIFY' ||  UserRequest::$request['ac'] == 'DUPLICATE'){ 
			//$sqty = ClxCommon::$db->countRecords($this->litrname, '	ID = ' . singleQuote($record ['LITR_ID']).' AND (TRANS_STATUS= '. singleQuote('PROC') . ' OR  TRANS_STATUS= '. singleQuote('ANUL') . ')');
			$sqty = ClxCommon::$db->countRecords($this->litrname, '	ID = ' . singleQuote($record ['LITR_ID']).' AND (TRANS_STATUS= '. singleQuote('PROC') . ')');
			if ($sqty == CLX_NUM_ONE){
				$msg ['LITR_COMP_CODE'] = dict('CODE_ERR_NOTMODIFIED');
				$status = false;
			}else{
				if ($record['LITR_TRANS_STATUS']=='PROC'){
					$msg ['LITR_TRANS_STATUS']=dict('GEN_LBL_OPER_INVALID');
					$status = false;
				}
			}

			$qtylilo = ClxCommon::$db->countRecords($this->liloname, 'BRANCH_NO= '. singleQuote($record['LITR_BRANCH_NO']) . ' AND  SUBSYS_CODE= '. singleQuote($record['LITR_SUBSYS_CODE']) . ' AND LOAN_NO= '. singleQuote($record['LITR_LOAN_NO']). ' AND COMP_CODE= '.singleQuote($record['LITR_COMP_CODE']));
			if ($qtylilo  == 0){
					$msg ['LITR_COMP_CODE']=dict('GEN_LBL_LOAN_INVALID');
					$status = false;
			}
		    if ($status){
				$record ['LITR_OBSERVATION']='';
			}
		}
		if (UserRequest::$request['ac'] == 'DELETE'){
			    if ($record['LITR_TRANS_STATUS']=='PROC'){
					$msg ['LITR_COMP_CODE']=dict('GEN_LBL_OPER_INVALID');
					addMessage($msg ['LITR_COMP_CODE'], $record['LITR_LOAN_CD']);
					$status = false;
				}
		}
		
		return $status;
	}


// end method
    /**
     * createLidt
     *
     * @param array $record
     */
    function createLidt(&$record) {
        $rec = array();
        $results = ClxCommon::$db->executeQuery('SELECT FIELDNAME FROM CLX_DB_TABLEFIELDS WHERE TABLECODE = ' . singleQuote('LIDT') . ' AND FIELDNAME <> ' . singleQuote('ID'));
        while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
            if ($result ['FIELDNAME'] === 'IDCODE') {
                $rec ['IDCODE'] = $record ['IDCODE'];
                continue;
            }
			if (array_key_exists($result ['FIELDNAME'], $record)) {
                $rec [$result ['FIELDNAME']] = $record [$result ['FIELDNAME']];
            }
        }
		ClxCommon::$db->freeResult($results);
        if (!empty($rec))
            ClxCommon::$db->createRecord($this->lidtname, $rec, false);
    }
	
	
	//function proc_validate_transaction
	
	function proc_Transactions(&$msg, $record){
		$idlist = toString(getIdlist());
 
		
		
		//marcacamos transacciones con error aquellas que no tengan Codigo de Agencia, codigo de  Subaplicaicón, codigo prestamo y tipo de seguro
		$this->proc_mark_trans_error($idlist);
		//marcacamos transacciones con error aquellas que tengan Codigo de prestamo que no exista en el  catalogo de prestamos
		$this->proc_mark_trans_err_loan($idlist);
		//marcacamos transacciones con error aquellas que tengan monto igual a cero
		$this->proc_mark_trans_atm_cero($idlist);
		
		//actualizar saldos de seguro
		$sql='SELECT ID, BRANCH_NO, SUBSYS_CODE, LOAN_NO, COMP_CODE, TRANS_DATE, INSURANCE_TYPE, TRANS_AMT SUBTOTAL, TRANS_STATUS FROM ' . $this->litrname . ' WHERE TRANS_STATUS='. singleQuote('PEND') . ' AND ID IN (' . $idlist . ')';
		
		$results = ClxCommon::$db->executeQuery($sql);

		while ($result = ClxCommon::$db->getNextRecord($results, ASSOCIATIVE)) {
		    
			//procesamos la transacción
			$this->proc_actual_saldos_prestamos($result);
			//echo $result['TRANS_STATUS'];
			//pre($result);	
		}
		ClxCommon::$db->freeResult($results);
		
		
		
		//exit;
		
	}
	
	function proc_mark_trans_error($idlist){
		//--## MAIN#8, MARCAMOS TRANSACCIONES CON ERRORES PARA QUE SEAN REVISADAS Y NO PROCESARLAS AUTOMATICAMENTE ##--
		
        $sql='UPDATE LOIN_TRANSACTIONS SET TRANS_STATUS='. singleQuote('ERR') .', OBSERVATION='. singleQuote('Campos necesarios para procesar transacción en Blanco').' WHERE  ((BRANCH_NO IS NULL OR BRANCH_NO='. singleQuote('') .') OR (SUBSYS_CODE IS NULL OR SUBSYS_CODE='. singleQuote('') .') OR (LOAN_NO IS NULL OR LOAN_NO='. singleQuote('') .') OR (INSURANCE_TYPE IS NULL OR INSURANCE_TYPE='. singleQuote('') .'))' . ' AND ID IN (' . $idlist . ')';
		
		ClxCommon::$db->executeQuery($sql);

		
	}
	
	function proc_mark_trans_err_loan($idlist){
	    //--## MAIN#8, MARCAMOS TRANSACCIONES COMO CANCELADAS SI LA TRANSACCION TIENE UN NUMERO DE PRESTAMO QUE NO EXISTA EN CATALOGO DE PRESTAMO Y NO PROCESARLAS ##--

		$sql='UPDATE LOIN_TRANSACTIONS LITR SET TRANS_STATUS='. singleQuote('ERR') .', OBSERVATION='. singleQuote('Código de préstamo no existe').' WHERE ID IN (' . $idlist . ') AND TRANS_STATUS='. singleQuote('PEND') .' AND (BRANCH_NO || SUBSYS_CODE || LOAN_NO) NOT IN (SELECT (LILO.BRANCH_NO || LILO.SUBSYS_CODE || LILO.LOAN_NO) FROM  LOIN_LOANS LILO WHERE LILO.COMP_CODE=LITR.COMP_CODE)';
	    
		ClxCommon::$db->executeQuery($sql);

	
	}
	
	function proc_mark_trans_atm_cero($idlist){
	    //## MAIN#8, MARCAMOS TRANSACCIONES COMO CANCELADAS SI LA TRANSACCION TIENE UN MONTO IGUAL A CERO Y NO PROCESARLAS ##

		$sql='UPDATE LOIN_TRANSACTIONS LITR SET TRANS_STATUS='. singleQuote('ERR') .', OBSERVATION='. singleQuote('Monto no puede ser igual a cero').' WHERE ID IN (' . $idlist . ') AND TRANS_STATUS='. singleQuote('PEND') .' AND TRANS_AMT=0';
	    
		ClxCommon::$db->executeQuery($sql);

	
	}
	
	function proc_actual_saldos_prestamos($record){
		/*## INSLIBA#1, ACTUALIZA SALDOS DE PRESTAMOS CON TRANSACCIONES##*/
		$tablename='LOIN_INS_BALANCES';
		$tablename2='LOIN_TRANSACTIONS';
		//pre($record);

		$sql = 'SELECT COUNT(*) FROM '.$tablename.' WHERE
		SUBSYS_CODE= '. singleQuote($record['SUBSYS_CODE']) .'
		AND BRANCH_NO='. singleQuote($record['BRANCH_NO']) . '
		AND LOAN_NO='. singleQuote($record['LOAN_NO']) . '
		AND COMP_CODE='. singleQuote($record['COMP_CODE']). '
		AND INSURANCE_TYPE='. singleQuote($record['INSURANCE_TYPE']);

		//echo $sql;

		if (ClxCommon::$db->getOne($sql)==0){

			//SI NO EXISTE ENTRADA DE SALDO DE PRESTAMO  ENTONCES SE AGREGA DIRECTAMENTE SIN ARITMETICA
			$sql2='INSERT INTO LOIN_INS_BALANCES
			(
			SUBSYS_CODE,
			BRANCH_NO,
			LOAN_NO,
			COMP_CODE,
			EFFTDATE,
			INSURANCE_TYPE,
			BAL_AMT,
			CDATE,
			CREATEDBY,
			MDATE,
			MODIFIEDBY
			 ) VALUES( '.
			singleQuote($record['SUBSYS_CODE']) .
			', '.singleQuote($record['BRANCH_NO']) .
			', '.singleQuote($record['LOAN_NO']) .
			', '.singleQuote($record['COMP_CODE']) .
			', '.singleQuote($record['TRANS_DATE']) .
			', '.singleQuote($record['INSURANCE_TYPE']) .
			', '.singleQuote($record['SUBTOTAL']) .
			', CURRENT_TIMESTAMP 
			, '.singleQuote($_SESSION ['user_record'] ['username']) .
			', CURRENT_TIMESTAMP 
			, '.singleQuote($_SESSION ['user_record'] ['username']) .
			')';

			ClxCommon::$db->executeQuery($sql2);

		}else{

			$sql4 = 'UPDATE '.$tablename.' SET BAL_AMT=BAL_AMT + '.$record['SUBTOTAL'] .
			', MDATE=CURRENT_TIMESTAMP, MODIFIEDBY= '.singleQuote($_SESSION ['user_record'] ['username']) .' 
			WHERE
			SUBSYS_CODE= '. singleQuote($record['SUBSYS_CODE']) .'
			AND BRANCH_NO='. singleQuote($record['BRANCH_NO']) . '
			AND LOAN_NO='. singleQuote($record['LOAN_NO']) . '
			AND COMP_CODE='. singleQuote($record['COMP_CODE']). '
			AND INSURANCE_TYPE='. singleQuote($record['INSURANCE_TYPE']);
			ClxCommon::$db->executeQuery($sql4);

		}

		/*ACTUALIZAMOS STATUS DE LA TRANSACCION PROCESADA*/
		$sql3 = 'UPDATE '.$tablename2.' SET TRANS_STATUS='. singleQuote('PROC') .
		', OBSERVATION= '.singleQuote('').', MDATE=CURRENT_TIMESTAMP, MODIFIEDBY= '.singleQuote($_SESSION ['user_record'] ['username']) .'  
		WHERE
		ID= '. singleQuote($record['ID']) .'
		AND SUBSYS_CODE= '. singleQuote($record['SUBSYS_CODE']) .'
		AND BRANCH_NO='. singleQuote($record['BRANCH_NO']) . '
		AND LOAN_NO='. singleQuote($record['LOAN_NO']) . '
		AND COMP_CODE='. singleQuote($record['COMP_CODE']). '
		AND INSURANCE_TYPE='. singleQuote($record['INSURANCE_TYPE']);
		ClxCommon::$db->executeQuery($sql3);

		ClxCommon::$db->executeQuery('COMMIT');

		
	}


}

// end class