

function crrpInitForm(){


        $("#CRRP_LOAN_CODE").change(crrpFindFeesNames);

        //Amounts
        $("#CRRP_CAP_PAYMENT_AMT").change(crrpCalcTransAmt);
        $("#CRRP_INT_CAP_AMT").change(crrpCalcTransAmt);
        $("#CRRP_INT_DISP_AMT").change(crrpCalcTransAmt);
        $("#CRRP_INT_PAYMENT_AMT").change(crrpCalcTransAmt);
        $("#CRRP_LOAN_PERIOD").change(CrrpCalcNoPayments);
        $("#CRRP_PERIOD_TYPE").change(CrrpCalcNoPayments);
        $("#CRRP_PAYMENT_FREQ").change(CrrpCalcNoPayments);

        for(var i = 1; i<=5; i++){
            $("#CRRP_FEE_0"+i+"_CAP_AMT").change(crrpCalcTransAmt);
            $("#CRRP_FEE_0"+i+"_PAY_AMT").change(crrpCalcTransAmt);
            $("#CRRP_FEE_0"+i+"_DISP_AMT").change(crrpCalcTransAmt);
        }

	$(function() {
	    $("#CRRP_INTEREST_CALC option").each(function(i){
	    	switch($(this).val()){
		    	case '30/360': case 'AC/360': case '':
		    	case '30/365': case 'AC/365': case 'AC/AC':
		    		$(this).hide();
		    	break;
		    	default:
		    	break;
		    };
	    });
	});

	crrpFindFeesNames();
        crrpCalcTransAmt();
}


function crrpCalcTransAmt(){

    var cap = 0.00;
    var inte = 0.00;
    var fee = 0.00;

    //Monto de capital
    cap += parseFloat($("#CRRP_CAP_PREV_AMT").val());
    cap -= parseFloat($("#CRRP_CAP_PAYMENT_AMT").val());
    //Int Cap
    cap += parseFloat($("#CRRP_INT_CAP_AMT").val());
    cap += parseFloat($("#CRRP_FEE_01_CAP_AMT").val());
    cap += parseFloat($("#CRRP_FEE_02_CAP_AMT").val());
    cap += parseFloat($("#CRRP_FEE_03_CAP_AMT").val());
    cap += parseFloat($("#CRRP_FEE_04_CAP_AMT").val());
    cap += parseFloat($("#CRRP_FEE_05_CAP_AMT").val());

    //Interes
    inte += parseFloat($("#CRRP_INT_PREV_AMT").val());
    inte -= parseFloat($("#CRRP_INT_PAYMENT_AMT").val());
    inte -= parseFloat($("#CRRP_INT_CAP_AMT").val());
    inte -= parseFloat($("#CRRP_INT_DISP_AMT").val());

    //
    for(var i = 1; i<=5; i++){
        fee = parseFloat($("#CRRP_FEE_0"+i+"_AMT").val());

        if(fee==0){
            $("#CRRP_FEE_0"+i+"_CAP_AMT").val(numDec(0,2));
            $("#CRRP_FEE_0"+i+"_DISP_AMT").val(numDec(0,2));
            $("#CRRP_FEE_0"+i+"_CAP_AMT").attr("readonly", true);
            $("#CRRP_FEE_0"+i+"_CAP_AMT").attr("class", "readonly");
            $("#CRRP_FEE_0"+i+"_DISP_AMT").attr("readonly", true);
            $("#CRRP_FEE_0"+i+"_DISP_AMT").attr("class", "readonly");
            var fee_fin = parseFloat($("#CRRP_FEE_0"+i+"_FIN_PER").val());
            var fee_pct = parseFloat($("#CRRP_FEE_0"+i+"_RATE").val());
            var fee_formula = $("input:hidden[name=CRRP_FEE_0"+i+"_FORMULA]").val();
            if(fee_pct>0 && fee_fin==0 && fee_formula == 'P0006'){
                var a = (parseFloat($("#CRRP_INT_PAYMENT_AMT").val())+parseFloat($("#CRRP_CAP_PAYMENT_AMT").val()))*(fee_pct/100);
                var fee_pay = numDec(a,2);
                $("#CRRP_FEE_0"+i+"_PAY_AMT").val(fee_pay);
            }

        }else{
            $("#CRRP_FEE_0"+i+"_CAP_AMT").attr("readonly", false);
            $("#CRRP_FEE_0"+i+"_CAP_AMT").attr("class", "hasCalculator");
            $("#CRRP_FEE_0"+i+"_DISP_AMT").attr("readonly", false);
            $("#CRRP_FEE_0"+i+"_DISP_AMT").attr("class", "hasCalculator");



        }

        fee -= parseFloat($("#CRRP_FEE_0"+i+"_PAY_AMT").val());
        fee -= parseFloat($("#CRRP_FEE_0"+i+"_CAP_AMT").val());
        fee -= parseFloat($("#CRRP_FEE_0"+i+"_DISP_AMT").val());
        if(parseFloat($("#CRRP_FEE_0"+i+"_AMT").val())!=0){
            $("#CRRP_FEE_0"+i+"_END_AMT").val(numDec(fee,2));
        }
    }


    //Setting totals
    $("#CRRP_CAP_ENDING_AMT").val(numDec(cap,2));
    $("#CRRP_INT_ENDING_AMT").val(numDec(inte,2));


}



/**
 * Localiza el monto de interes para reserva
 */
function crrpFindFeesNames(){

	//GLPV
        var ac = $('input:hidden[name=ac]').val();
	var loan_code = $("#CRRP_LOAN_CODE").val();
        if(loan_code.length == 0) return;

	$.ajax({type: "GET",
		url: "window.php?to=DBQY&ac=QXML&no_menu=1&no_alerts=1&qy=FILO_CRRP_JS&fn=FILO.IDCODE&fv="+loan_code,
		dataType: "xml",
		success: function(xml) {
			$(xml).find('FILO_CRRP_JS').each(function(){
				var self = this;
				var fm1 = CrrpFeesFormulaLbl($(self).find('GLPF_FEE_01_FORMULA_WRK').text());
				var fm2 = CrrpFeesFormulaLbl($(self).find('GLPF_FEE_02_FORMULA_WRK').text());
				var fm3 = CrrpFeesFormulaLbl($(self).find('GLPF_FEE_03_FORMULA_WRK').text());
				var fm4 = CrrpFeesFormulaLbl($(self).find('GLPF_FEE_04_FORMULA_WRK').text());
				var fm5 = CrrpFeesFormulaLbl($(self).find('GLPF_FEE_05_FORMULA_WRK').text());

				$("#CRRP_FEE_01_NAME").val(fm1+$(self).find('GLPF_FEE_01_NAME_WRK').text());
				$("#CRRP_FEE_02_NAME").val(fm2+$(self).find('GLPF_FEE_02_NAME_WRK').text());
				$("#CRRP_FEE_03_NAME").val(fm3+$(self).find('GLPF_FEE_03_NAME_WRK').text());
				$("#CRRP_FEE_04_NAME").val(fm4+$(self).find('GLPF_FEE_04_NAME_WRK').text());
				$("#CRRP_FEE_05_NAME").val(fm5+$(self).find('GLPF_FEE_05_NAME_WRK').text());

                                $("#CRRP_FEE_01_NAME2").val($("#CRRP_FEE_01_NAME").val());
				$("#CRRP_FEE_02_NAME2").val($("#CRRP_FEE_02_NAME").val());
				$("#CRRP_FEE_03_NAME2").val($("#CRRP_FEE_03_NAME").val());
				$("#CRRP_FEE_04_NAME2").val($("#CRRP_FEE_04_NAME").val());
				$("#CRRP_FEE_05_NAME2").val($("#CRRP_FEE_05_NAME").val());


                                $("input:hidden[name=CRRP_FEE_01_FORMULA]").val($(self).find('GLPF_FEE_01_FORMULA_WRK').text());
                                $("input:hidden[name=CRRP_FEE_02_FORMULA]").val($(self).find('GLPF_FEE_02_FORMULA_WRK').text());
                                $("input:hidden[name=CRRP_FEE_03_FORMULA]").val($(self).find('GLPF_FEE_03_FORMULA_WRK').text());
                                $("input:hidden[name=CRRP_FEE_04_FORMULA]").val($(self).find('GLPF_FEE_04_FORMULA_WRK').text());
                                $("input:hidden[name=CRRP_FEE_05_FORMULA]").val($(self).find('GLPF_FEE_05_FORMULA_WRK').text());


                                if(parseFloat($("#CRRP_FEE_01_AMT").val())==0)
                                    $("#CRRP_FEE_01_AMT").val(numDec(parseFloat($(self).find('FILO_FEE_01_AMT').text()),2));
                                if(parseFloat($("#CRRP_FEE_02_AMT").val())==0)
                                    $("#CRRP_FEE_02_AMT").val(numDec(parseFloat($(self).find('FILO_FEE_02_AMT').text()),2));
                                if(parseFloat($("#CRRP_FEE_03_AMT").val())==0)
                                    $("#CRRP_FEE_03_AMT").val(numDec(parseFloat($(self).find('FILO_FEE_03_AMT').text()),2));
                                if(parseFloat($("#CRRP_FEE_04_AMT").val())==0)
                                    $("#CRRP_FEE_04_AMT").val(numDec(parseFloat($(self).find('FILO_FEE_04_AMT').text()),2));
                                if(parseFloat($("#CRRP_FEE_05_AMT").val())==0)
                                    $("#CRRP_FEE_05_AMT").val(numDec(parseFloat($(self).find('FILO_FEE_05_AMT').text()),2));
                                //rates
                                if(parseFloat($("#CRRP_FEE_01_RATE").val())==0)
                                    $("#CRRP_FEE_01_RATE").val(numDec(parseFloat($(self).find('FILO_FEE_01_RATE').text()),5));
                                if(parseFloat($("#CRRP_FEE_02_RATE").val())==0)
                                    $("#CRRP_FEE_02_RATE").val(numDec(parseFloat($(self).find('FILO_FEE_02_RATE').text()),5));
                                if(parseFloat($("#CRRP_FEE_03_RATE").val())==0)
                                    $("#CRRP_FEE_03_RATE").val(numDec(parseFloat($(self).find('FILO_FEE_03_RATE').text()),5));
                                if(parseFloat($("#CRRP_FEE_04_RATE").val())==0)
                                    $("#CRRP_FEE_04_RATE").val(numDec(parseFloat($(self).find('FILO_FEE_04_RATE').text()),5));
                                if(parseFloat($("#CRRP_FEE_05_RATE").val())==0)
                                    $("#CRRP_FEE_05_RATE").val(numDec(parseFloat($(self).find('FILO_FEE_05_RATE').text()),5));

                                //Finance
                                if(parseFloat($("#CRRP_FEE_01_FIN_PER").val())==0)
                                    $("#CRRP_FEE_01_FIN_PER").val(numDec(parseFloat($(self).find('FILO_FEE_01_FIN_PER').text()),0));
                                if(parseFloat($("#CRRP_FEE_02_FIN_PER").val())==0)
                                    $("#CRRP_FEE_02_FIN_PER").val(numDec(parseFloat($(self).find('FILO_FEE_02_FIN_PER').text()),0));
                                if(parseFloat($("#CRRP_FEE_03_FIN_PER").val())==0)
                                    $("#CRRP_FEE_03_FIN_PER").val(numDec(parseFloat($(self).find('FILO_FEE_03_FIN_PER').text()),0));
                                if(parseFloat($("#CRRP_FEE_04_FIN_PER").val())==0)
                                    $("#CRRP_FEE_04_FIN_PER").val(numDec(parseFloat($(self).find('FILO_FEE_04_FIN_PER').text()),0));
                                if(parseFloat($("#CRRP_FEE_05_FIN_PER").val())==0)
                                    $("#CRRP_FEE_05_FIN_PER").val(numDec(parseFloat($(self).find('FILO_FEE_05_FIN_PER').text()),0));


                                if(parseFloat($("#CRRP_CAP_PREV_AMT").val())==0){
                                    var a = parseFloat($(self).find('FILO_PRINCIPAL_BAL').text());

                                    if(isNaN(a)) a = 0;
                                    $("#CRRP_CAP_PREV_AMT").val(numDec(a, 2));

                                }

                                if(parseFloat($("#CRRP_INT_PREV_AMT").val())==0){
                                    var inte = parseFloat($(self).find('FILO_INTEARNED_AMT').text()) - parseFloat($(self).find('FILO_INTPAID_AMT').text());
                                    if(isNaN(inte)) inte = 0;
                                    $("#CRRP_INT_PREV_AMT").val(numDec(inte, 2));
                                }

                                //

                                if($("#CRRP_FIDU_BANKACT_CODE").val().length==0){
                                    $("#CRRP_FIDU_BANKACT_CODE").val($(self).find('FILO_PAY_BANKACT_NO').text());
                                }


                                if($("#CRRP_CRED_PAY_METHOD").val().length==0){
                                    $("#CRRP_CRED_PAY_METHOD").val($(self).find('FILO_CRED_PAY_METHOD').text());
                                }

                                //Datos de intereses
                                if(parseFloat($("#CRRP_LOAN_INTEREST").val())==0){
                                    $("#CRRP_INTEREST_TYPE").val($(self).find('FILO_INTEREST_TYPE').text());
                                    $("#CRRP_ADJ_INDEX").val($(self).find('FILO_ADJ_INDEX').text());
                                    $("#CRRP_LOAN_INTEREST").val($(self).find('FILO_LOAN_INTEREST').text());
                                    $("#CRRP_INDEX_RATE").val($(self).find('FILO_INDEX_RATE').text());
                                    $("#CRRP_INTEREST_CALC").val($(self).find('FILO_INTEREST_CALC').text());
                                    $("#CRRP_ADJ_PATT_PERIOD").val($(self).find('FILO_ADJ_PATT_PERIOD').text());
                                    $("#CRRP_ADJ_PATTERN").val($(self).find('FILO_ADJ_PATTERN').text());
                                    $("#CRRP_ADJ_POINTS_OVERINDEX").val($(self).find('FILO_ADJ_POINTS_OVERINDEX').text());

                                }

                                if(parseFloat($("#CRRP_LOAN_PERIOD").val())==0){
                                    $("#CRRP_LOAN_PERIOD").val($(self).find('FILO_LOAN_PERIOD').text());
                                    $("#CRRP_PERIOD_TYPE").val($(self).find('FILO_PERIOD_TYPE').text());
                                    $("#CRRP_PAYMENT_FREQ").val($(self).find('FILO_PAYMENT_FREQ').text());
                                    $("#CRRP_NO_PAYMENTS").val($(self).find('FILO_NO_PAYMENTS').text());
                                    $("#CRRP_EQ_GRACE_PERIODS").val($(self).find('FILO_EQ_GRACE_PERIODS').text());
                                    $("#CRRP_INT_GRACE_PERIODS").val($(self).find('FILO_INT_GRACE_PERIODS').text());
                                }

                                crrpCalcTransAmt();
			});


		}
	});
}//end function

function CrrpFeesFormulaLbl(code){
	var lbl = '';
	if(code.charAt(0)=='P') lbl = '% ';
	return lbl;
}


function CrrpCalcNoPayments(){

	var payfreq = parseFloat($("#CRRP_PAYMENT_FREQ").val());
	var period =  parseFloat($("#CRRP_LOAN_PERIOD").val());
	var periodtype = $("#CRRP_PERIOD_TYPE").val();
	var periodfactor = 0;
	if(isNaN(period)){
		period = 0;
		$("#CRRP_LOAN_PERIOD").val(0);
	}
	if(periodtype=='D') periodfactor = 360;
	else if(periodtype=='W') periodfactor = 52;
	else if(periodtype=='M') periodfactor = 12;
	else if(periodtype=='Q') periodfactor = 4;
	else if(periodtype=='S') periodfactor = 2;
	else if(periodtype=='Y') periodfactor = 1;
	else periodfactor = 0;
	var nopay = 0;
	if(periodfactor>0){
		nopay = period*(payfreq/periodfactor);
	}
	if(payfreq==99){
		nopay = 1;
	}
	$("#CRRP_NO_PAYMENTS").val(Math.round(nopay));

	//Check for ballon payments
	CrrpCalcNoBallonPayments();
}//end function

/**
 * Calculates number of ballon payments
 */
function CrrpCalcNoBallonPayments(){
	var period =  parseFloat($("#CRRP_LOAN_PERIOD").val());
	if(isNaN(period)){
            $("#CRRP_LOAN_PERIOD").val(0);
	}
}//end function