<?php
/**
 * Validate record information
 * Executed on table validate
 */
function glcp_validate_form(&$record, &$msg) {

    if (ClxCommon::$db->oneExistsRecords('GL_CODES_TBL', 'GLGROUP_CODE = ' . singleQuote($record['GLCP_GLGROUP_CODE']) . ' AND IDCODE = ' . singleQuote($record['GLCP_RET_EARNING_CODE'])) === CLX_NUM_ZERO) {
        $msg['GLCP_RET_EARNING_CODE'] = 'GLCP01 ' . dict('CODE_ERR_GLGROUPNOTMATCHFORCOMP');
    }

    //Validar que sea una cuenta contable de grupo contable correcto.
    if (ClxCommon::$db->oneExistsRecords('GL_CODES_TBL', 'GLGROUP_CODE = ' . singleQuote($record['GLCP_GLGROUP_CODE']) . ' AND IDCODE = ' . singleQuote($record['GLCP_ACR_EARNING_CODE'])) === CLX_NUM_ZERO) {
        $msg['GLCP_ACR_EARNING_CODE'] = 'GLCP02 ' . dict('CODE_ERR_GLGROUPNOTMATCHFORCOMP');
    }
}
