<?php

//	CONSTANTS_PROC_ENGINE.PHP
//	Process Engine Constants.  Or in windows, 'the ini file'
//	Date:
// System Version
define('kSystemVersion', '5.5.0.0');
// System Language
define('kSystemLanguage', 'es');
//-- DATABASE PARAMETERS
// Database type: mysql | mssql
if (!defined('kDatabaseType'))
    define('kDatabaseType', 'mysql');
// Database URL, usualy is 'localhost' if Apache/IIS is running in the same machine as
// the MySQL Server.  If not, is an ip address or url.
if (!defined('kDatabaseURL'))
    define('kDatabaseURL', 'localhost');
// The user name and password to access the Database Server
if (!defined('kDatabaseUsername'))
    define('kDatabaseUsername', 'dbuser');
if (!defined('kDatabasePassword'))
    define('kDatabasePassword', 'dbpass');
// The database name...
if (!defined('kDatabaseName'))
    define('kDatabaseName', 'dbname');
//Mysql Version, current version 5+
//For mysql prior to 50 set 41, 40 etc
if (!defined('kMysqlVersion'))
    define('kMysqlVersion', '5.0');
//-- DIRECTORY PARAMETERS
// The absolute path to the system.  If you are on a Windows system
// this path will be something like: 'c:/Inetpub/wwwroot/clientix/'.
// On a Unix/Linux system it will be something like: '/user/docs/http/'

define('kPathToWebSite', '/var/www/html/cda55dev/');
// Directory name.' WHERE the tools are stored...
//(make sure it ends with '/', usualy 'tools/')
define('kPathToTools', 'tools/');
// Directory name.' WHERE the objects are stored...
// (make sure it ends with '/', usualy 'objects/')
define('kPathToObjects', 'objects/');
// Directory to save uploaded files
// (make sure it ends with '/', usualy 'data/files/')
define('kPathToData', 'data/files/');
// Directory to save uploaded code
// (make sure it ends with '/', usualy 'data/code/')
define('kPathToCode', 'data/code/');
// Directory to save uploaded templates
// (make sure it ends with '/', usualy 'data/code/')
define('kPathToTemplates', 'data/templates/');
// Directory to save packages
//(make sure it ends with '/', usualy 'packages/')
define('kPathToPackages', 'packages/');
// Directory to save skins
//(make sure it ends with '/', usualy 'skins/')
define('kPathToSkins', 'skins/');
// Directory to save export fiels
// (this directory should exist, make sure it ends with '/', usualy 'temp/')
define('kPathToExport', 'export/');
// Directory to save temporal files
// (this directory should exist, make sure it ends with '/', usualy 'temp/')
define('kPathToTemp', 'temp/');
// Directory to save temporal files
// (this directory should exist, make sure it ends with '/', usualy 'temp/')
define('kPathToPear', 'PEAR/');
// Directory to save temporal files
// (this directory should exist, make sure it ends with '/', usualy 'temp/')
define('kPathToSendmail', '/usr/lib/sendmail');
// PDF Forms direct acces to the pictures.
define('kDirectPathToArchive', kPathToWebSite . 'data/archive/');
// The name of the web site.
define('kWebSite', 'http://74.246.58.179/cda55dev/');
// PDF Forms direct acces to the pictures.
//-- MAIL PARAMETERS
//Default Email Account
define('kDefaultEmail', 'support@alenet.com');
//Default SMTP Server. Default outgoing mail server
define('kDefaultSmtp', 'localhost');
//Default SMTP Server port. Default outgoing mail server port
define('kDefaultSmtpPort', '25');
//Default mailer. Options (mail, pear). If smtp requires authentication user pear
define('kDefaultMailer', 'mail');
//Default SMTP Requires autentication. Set true if requires autentication.
//Default Mailer must be pear
define('kDefaultSmtpReqAuth', false);
//Default SMTP username. If authentication required, set username for smtp
define('kDefaultSmtpUsername', '');
//Defautl SMTP password.  If authentication required, set username for smtp
define('kDefaultSmtpPassword', '');
//-- OTHER PARAMETERS
// PHP Command Line Interpreter
define('kPhpCLI', '/usr/bin/php');
//Database default backup folder
define('kDbBackupFolder', '/home/alenetdev/daily_dbbackups/');
//Math Functions Precision (Number of decimal Places)
define('kDefaultPrecision', CLX_NUM_28);
// Name of the default skin
define('kDefaultSkin', 'default');
// Set true to Remove Back Button From Browser
define('kDefaultFrameLess', false);
// Name of the company
define('kDefaultCompany', 'Alenet, Inc.');
// Cookie name to store the last menu opened by the user.
// (Usualy 'Clientix_MenuBar_option')
define('kSideBarCookieName', 'Clientix_MenuBar_option');
//Session Timeout in minutes, set to 0 for no end.
define('kSessionTimeout', '30');
//Script execution time limit in seconds, set to 0 for no end. Default = 90
define('kTimeLimit', CLX_NUM_ZERO);
//Multi Session, set to true to allow same user to open more than one session at the
//Same time or falsto restrict only one session per user
define('kSessionMultiple', true);
//This sets the maximum amount of memory in bytes that a script is allowed to allocate.
//This helps prevent scripts for eating up all available memory on a server. Sample: 8M or -1 to no limit
define('kAppMemoryLimit', '50M');
//This defines the maximum file size for uploads. Sample: 8M
define('kAppMaxUploadSize', '50M');
//This defines the maximum post method size allowed for the application. Sample: 8M
define('kAppMaxPostSize', '50M');
//Develoment Platform
define('kAppDev', 'false');
//Define Application TypeZone see http://us3.php.net/manual/en/timezones.php
define('kDefaultTimeZone', 'America/New_York');
//PHP Error parameters
define('kPhpDisplayErrors', true);
define('kPhpLogErrors', true);
define('kPhpErrorLog', 'error_log.txt');
