<?php

/**
 * General Functions
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-09-28 14:58:40 +0000 (Thu, 28 Sep 2017) $
 * @version        $Rev: 9536 $
 *
 * CHANGE LOG
 *  Included label
 */

if (!file_exists(kPathToWebSite . 'includes/interface.php')) {
    print 'Invalid kPathToWebsite: ' . kPathToWebSite;
    include (kPathToWebSite . 'includes/util.php');
    salir();
    //bool trigger_error ( string $error_msg [, int $error_type = E_USER_NOTICE ] )
}

// INCLUDES
require_once kPathToWebSite . 'classes/ClxCommon.php';
require_once kPathToWebSite . 'classes/UserRequest.php';
require_once kPathToWebSite . 'classes/UserResponse.php';
require_once kPathToWebSite . 'includes/sys_constants.php';
require_once kPathToWebSite . 'includes/interface.php';
require_once kPathToWebSite . 'includes/util.php';

// CLASSES
require_once kPathToWebSite . 'classes/adodb-time.php';
require_once kPathToWebSite . 'classes/xdebug.php';
require_once kPathToWebSite . 'classes/xvalidate.php';
require_once kPathToWebSite . 'classes/xformat.php';
require_once kPathToWebSite . 'classes/TextualNumber.php';
require_once kPathToWebSite . 'classes/xpaging.php';
require_once kPathToWebSite . 'classes/xml.php';
require_once kPathToWebSite . 'classes/html.php';
require_once kPathToWebSite . 'classes/clx_field.php';
require_once kPathToWebSite . 'classes/clx_form.php';
require_once kPathToWebSite . 'classes/clx_object.php';
require_once kPathToWebSite . 'classes/clx_listing.php';
require_once kPathToWebSite . 'classes/ClxAccess.php';
require_once kPathToWebSite . 'classes/clx_tool.php';
require_once kPathToWebSite . 'classes/ClxSession.php';
require_once kPathToWebSite . 'classes/clx_socket.php';
require_once kPathToWebSite . 'classes/clx_filesystem.php';
require_once kPathToWebSite . 'classes/clx_file.php';
require_once kPathToWebSite . 'classes/clx_ftp.php';
require_once kPathToWebSite . 'classes/ClxDatabase.php';
require_once kPathToWebSite . 'classes/ClxExpression.php';

//Load connection
UserRequest::sanitizeUserInput();
if(!isset($kDatabase)){
    $kDatabase = null;
}

loadDbnOptions($kDatabase);
