<?php

/**
 * Login image will to check user login
 * Default page where all requests are going to be handled
 *
 * @author       $Author: imrsnik $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-08-19 14:50:21 +0000 (Wed, 19 Aug 2015) $
 * @version    	$Rev: 6556 $
 */
require 'constants.php';
require 'includes.php';
PrepareConstants();
ConnectToDatabase();
initTools();
/* if there is a key */
if ($_SESSION['login_key'] === true) {
    /* define that the browser should treat
      the output of this file as an image */
    header('Content-type: image/png');
    // set the string to the key
    $string = $_SESSION['login_key'];
    // create an temporary image from a PNG file
    $im = imagecreatefromgif('bg_login_key.gif');
    // get a color from the image (in this case, yellow)
    $orange = imagecolorallocate($im, CLX_NUM_120, CLX_NUM_110, CLX_NUM_200);
    /* Now we need to get widh and height of the image,
     * so that we can center the key on the image, so
     * that it does not go outside of the borders or look strange */
    $px = (imagesx($im) - CLX_NUM_7_PT_5 * strlen($string)) / CLX_NUM_TWO;
    $h = (imagesy($im) - CLX_NUM_7_PT_5) / CLX_NUM_TWO;
    // here we write the key (the string)  on the image
    imagestring($im, CLX_NUM_8, $px, $h, $string, $orange);
    // now create the final image
    imagepng($im);
    // to free up results, we need to destroy the temporary image.
    imagedestroy($im);
}//end if
