

function processForm() {
    var rel_type = $('#DBDR_relation_type').val();
    var status = true;
    var vals = '';
    var comma = '';
    var valsmn = '';
    var commamn = '';
    var i = 0;

    $('#theForm').children().find('select').each(
            function () {
                var self = this;
                if (rel_type == 1 && self.id.search(/parentfls/i) >= 0) {

                    var j = $('#' + self.id).attr('it');
                    if ($('#parentfls' + j).val() == '') {
                        $('#parentfls' + j).css('background', 'red');
                        $('#parentfls' + j).css('color', 'white');
                        status = false;
                    } else {
                        $('#parentfls' + j).css('background', 'white');
                        $('#parentfls' + j).css('color', 'black');
                    }

                    if ($('#childfls' + j).val() == '') {
                        $('#childfls' + j).css('background', 'red');
                        $('#childfls' + j).css('color', 'white');
                        status = false;
                    } else {
                        $('#childfls' + j).css('background', 'white');
                        $('#childfls' + j).css('color', 'black');
                    }

                    var copy = 0;
                    if ($('#copyfls' + j).is(':checked')) {
                        copy = 1;
                    }
                    vals += comma + $('#parentfls' + j).val() + ':' + $('#childfls' + j).val() + ':' + copy;
                    comma = ',';
                    i++;
                }

                //mns
                if (rel_type == 2 && self.id.search(/parentflsmn/i) >= 0) {

                    var j = $('#' + self.id).attr('it');
                    if ($('#parentflsmn' + j).val() == '') {
                        $('#parentflsmn' + j).css('background', 'red');
                        $('#parentflsmn' + j).css('color', 'white');
                        status = false;
                    } else {
                        $('#parentflsmn' + j).css('background', 'white');
                        $('#parentflsmn' + j).css('color', 'black');
                    }

                    if ($('#childflsmn' + j).val() == '') {
                        $('#childflsmn' + j).css('background', 'red');
                        $('#childflsmn' + j).css('color', 'white');
                        status = false;
                    } else {
                        $('#childflsmn' + j).css('background', 'white');
                        $('#childflsmn' + j).css('color', 'black');
                    }

                    var copy = 0;
                    if ($('#copyflsmn' + j).is(':checked')) {
                        copy = 1;
                    }
                    valsmn += commamn + $('#parentflsmn' + j).val() + ':' + $('#childflsmn' + j).val() + ':' + copy;
                    commamn = ',';
                    i++;
                }


            }
    );
    $('input[name=DBDR_relation_fields]').val(vals);
    $('input[name=DBDR_relation_fields_mn]').val(valsmn);
    return status;
}

function dbdr_rel_type_pane() {
    if ($('#DBDR_relation_type').val() == 0) {
        $('#DBDR_DYNAMIC').show();
        $('#DBDR_ONETOONE').hide();
        $('#DBDR_MTON').hide();
    } else if ($('#DBDR_relation_type').val() == 2) {
        $('#DBDR_DYNAMIC').hide();
        $('#DBDR_ONETOONE').hide();
        $('#DBDR_MTON').show();
    } else {
        $('#DBDR_DYNAMIC').hide();
        $('#DBDR_ONETOONE').show();
        $('#DBDR_MTON').hide();
    }
}

function dbdr_expand_list() {

    var i = parseInt($('#relfields').attr('trows')) + 1;
    var s = '<tr id="relfield' + i + '"sclass="data">'
            + '<td><img src = "' + $('#relfields').attr('ic') + 'delete.gif" onClick="javascript:dbdr_contract_list(' + i + ');"></img></td>'
            + '<td><select id="parentfls' + i + '" name="parentfl' + i + '" it=' + i + '><option value=""></option></select>'
            + ' = '
            + '<select id="childfls' + i + '" name="childfl' + i + '" it=' + i + '><option value=""></option></select></td>'
            + '<td><input type="checkbox" id="copyfls' + i + '" name="copyfls' + i + '" value="1" checked=true/></td>'
            + '</tr>';
    $('#relfields').append(s);
    $('#relfields').attr('trows', i);

    //Populating table information
    dbdr_tb_fields('parentfls' + i, 0, 0);
    dbdr_tb_fields('childfls' + i, 1, 0);

}

function dbdr_expand_list_mn() {

    var i = parseInt($('#relfieldsmn').attr('trows')) + 1;
    var s = '<tr id="relfieldmn' + i + '"sclass="data">'
            + '<td><img src = "' + $('#relfieldsmn').attr('ic') + 'delete.gif" onClick="javascript:dbdr_contract_list_mn(' + i + ');"></img></td>'
            + '<td><select id="parentflsmn' + i + '" name="parentflmn' + i + '" it=' + i + '><option value=""></option></select>'
            + ' = '
            + '<select id="childflsmn' + i + '" name="childflmn' + i + '" it=' + i + '><option value=""></option></select></td>'
            + '<td><input type="checkbox" id="copyflsmn' + i + '" name="copyfls' + i + '" value="1" checked=true/></td>'
            + '</tr>';
    $('#relfieldsmn').append(s);
    $('#relfieldsmn').attr('trows', i);

    //Populating table information
    dbdr_tb_fields('parentflsmn' + i, 0, 1);
    dbdr_tb_fields('parentflsmn' + i, 1, 1);
    dbdr_tb_fields('childflsmn' + i, 2, 1);
}

function dbdr_contract_list(row) {
    $('#relfield' + row).remove();
}

function dbdr_contract_list_mn(row) {
    $('#relfieldmn' + row).remove();
}

function dbdr_tb_fields(flname, child, mode) {

    var tb = $('#DBDR_parent_tablecode').val();
    if (child == 1) {
        tb = $('#DBDR_child_tablecode').val();
    }
    if (child == 2) {
        tb = $('#DBDR_tablecode_mn').val();
    }

    var url = 'window.php?to=DBTF&nomenu=1&noalerts=1&ac=TBF_LIST_XML&tc=' + tb;
    $.ajax({
        type: 'GET',
        url: url,
        dataType: 'xml',
        success: function (xml) {

            $(xml).find('DBTF').each(function () {
                var self = this;
                var lbl = (mode == 0) ? $(self).find('FIELDNAME').text() : tb + '.' + $(self).find('FIELDNAME').text();
                $('#' + flname).append($('<option />').text(lbl).val(lbl));
            });
        }
    });

}


function dbdr_rel_type() {
    $('#DBDR_relation_type').change(dbdr_rel_type_pane);
    $('#DBDR_parent_tablecode').change(dbdr_tb_fields);
    $('#DBDR_child_tablecode').change(dbdr_tb_fields);
}

$(document).ready(dbdr_rel_type_pane);
$(document).ready(dbdr_rel_type);

