<?php

class get_options extends DomDocument{

	var $view = false;
	
	function action($idlist){
		$session = Validate::regular_session();
		if($session){
			return $session;
		}

		$doc = new DOMDocument();
		$doc->load(kData.opFile);

		$root = $doc->getElementsByTagName("options");
		$root = $root->item(0);


		$occ  = $doc->createElement('user');
		$occ  = $root->appendChild($occ);
		$value = $doc->createTextNode($_SESSION['user']);
		$value = $occ->appendChild($value);

		$occ  = $doc->createElement('version');
		$occ  = $root->appendChild($occ);
		$value = $doc->createTextNode(kSystemVersion);
		$value = $occ->appendChild($value);

		if($_SESSION['session'] != "Administrator\n"){
			$options = $doc->getElementsByTagName("options_set");
			for($index = 0; $index< $options->length; $index++){
				$option = $options->item($index);
				if($option->getAttribute('admin')=='true'){
					$parent = $option->parentNode;
					$parent->removeChild($option);
				}
			}
		}
		return $doc->saveXml();
	}
}
?>