<?php
class constants extends DOMDocument{
	function __construct($file,$xpengine){
		if(file_exists($file)){
			$doc = new DomDocument();
			$doc->load($file);
			$constants = $doc->getElementsByTagName('constant');
			foreach($constants as $constant){
				$name = $constant->getAttribute('name');
				$type = $constant->getAttribute('type');
				$value = $constant->nodeValue;
				switch($type){
					case 'negMB':
						if($value == '-1'){
							break;
						}
					case 'MB':
						$value = $value.'M';
						break;
					case 'int':
					case 'intBoolean':
						$value = (int)$value;
						break;
					case 'Boolean':
						if($value == 'true'){
							$value = true;
						}else{
							$value = false;
						}
						break;
							
					case 'Path':
						$value = constants::getSERVER($value);
						break;
					default:
						break;
				}
				if(!defined($name)){
					define($name,$value);
				}
			}
			$arrays = $doc->getElementsByTagName('array');
			foreach($arrays as $array){
				$name = $array->getAttribute('name');
				$tmp  = array();
				$indexes = $array->getElementsByTagName('index');
				$attributes = array();
				$radio = false;
				foreach($indexes as $index){
					$i = (int)$index->getAttribute('name');
					$tmp[$i] = array();
					$j = 0;
					$values = $index->getElementsByTagName('value');
					foreach($values as $value){
						if($i==0){
							$attributes[$j]= $value->getAttribute('name');
						}
						$type = $value->getAttribute('type');
						$result = $value->nodeValue;
						switch($type){
							case 'Port':
							case 'String':
							case 'option':
							case 'password':
							case 'date':
								break;
							case 'Path':
								$result = constants::getSERVER($result);
								break;
							case 'negMB':
								if($value == '-1'){
									break;
								}
							case 'MB':
								$result = $result.'M';
								break;
							case 'int':
								$result = (int)$result;
								break;
							case 'Boolean':
								if($result == 'true'){
									$result = true;
								}else{
									$result = false;
								}
								break;
							case 'intBoolean':
								if($value == '1'){
									$value = 1;
								}else{
									$value = 0;
								}
								break;
							case 'radio':
								if($result == ''){
									$result = 0;
								}
								$radio = $result;
								break;
						}
						$tmp[$i][$j] = $result;
						$j++;
					}
				}
				$$name = $name;
				global $$name;
				$$name = $tmp;

				if($xpengine && is_numeric($radio)){
					for($i=0;$i<count($tmp[$radio]);$i++){
						if(!defined($attributes[$i])){
							define($attributes[$i],$tmp[$radio][$i]);
						}
					}
				}
			}
		}else{
			include_once 'constants_jic.php';
		}
	}
	/* getSERVER
	 *
	 *
	 *  Checks a string and see if it can find a $_SERVER variable on it
	 *  then it replaces it with the appropiate variable, it has trouble
	 *  with white spaces so they should be used carefully
	 *  (as in not at all)
	 *
	 *  And to think i went through college  thinking i would never use
	 *  reg exp at work... thank god i learned them :-)
	 */

	function getSERVER($string){

		if(preg_match('/.*\$_SERVER\[.*\].*/',$string)){
			$index = preg_replace('/.*\$_SERVER\["/','', $string);
			$index = preg_replace('/"\].*/','', $index);
			$index = trim($index);

			$prefix = preg_replace('/\$_SERVER\[.*\].*/','', $string);
			$prefix = preg_replace('/"/','', $prefix);
			$prefix = preg_replace('/\./','', $prefix);
			$prefix = trim($prefix);

			$suffix = preg_replace('/.*\$_SERVER\[.*\]/','', $string);
			$suffix = preg_replace('/"/','', $suffix);
			$suffix = preg_replace('/\./','', $suffix);
			$suffix = trim($suffix);

			try{
				$result = $prefix.$_SERVER[$index].$suffix;
			}catch(Exception $err){
				return $string;
			}
			return $result;
		}else{
			return $string;
		}
	}
}
new constants('includes/constants/constants.xml',false);
?>