<?php

/**
 * Fidu - IBS Interface - Version Check
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2016-01-11 09:41:26 -0500 (Mon, 11 Jan 2016) $
 * @version        $Rev: 7678 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
/*
  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  RECORD OF CHANGES 24/01/2008		Se sacó de EIBS_utilities.php para poder compartirlo entre otros programas, tales como el reporte SUDEBAN
  07/07/2008	: se puso <?php en vez de <? al principio para evitar conflictos al hacer el include en Windows
  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 */
/*
 * Returns clientix version and a flag wich indicates old or new structure after version 5.0
 */
function clx_vers_check() {
    ////////////////////////////////////////////////////////////////////////
    // CLIENTIX VERSION: just to know the correct acco structure to use. 50 hasn´t the phones and addresses in ACCO and CONT record
    if (isset($GLOBALS['eibs_clx_vers'])) {
			 $eibs_clx_vers =$GLOBALS['eibs_clx_vers'];
	}
	else {
			$GLOBALS['eibs_clx_vers']=$eibs_clx_vers = companyParameter('CLX_VERSION');
    }
	
	
	
    if (is_null($eibs_clx_vers) || trim($eibs_clx_vers) === '')
        $eibs_clx_vers = '5.6';
    ////////////////////////////////////////////////////////////////////////
    // indicates old or new acco/cont tables structure version
    $sw_old_acco_struct = ($eibs_clx_vers < '5.5');
    return array('eibs_clx_vers' => $eibs_clx_vers,
        'sw_old_acco_struct' => $sw_old_acco_struct
    );
}
