<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-03 12:24:19 -0400 (Thu, 03 Sep 2015) $
 * @version        $Rev: 6814 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Asdo {

    /**
     * Constructor
     * @param array [$procParameters]
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('ASDO', 'FIAE', 'PROD', 'PRAT', 'GLAC', 'AAGI', 'AAGR'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->je_source = '';
    }

    /**
     * Initialice fiat form - Executed on init event
     *
     * @param unknown_type $record
     */
    function init_form(&$record) {
        if (UserRequest::$request['ac'] === 'CREATE' && empty(UserRequest::$post['confirm'])) {
		  $cp = peekHistory();
		  if (!empty($cp['parentrecord']['AAGR_CLX_EFFTDATE'])) {
			 $record['ASDO_EFFTDATE'] = $cp['parentrecord']['AAGR_CLX_EFFTDATE'];
		  }
        }
    }

}
