<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-10-12 07:55:36 -0400 (Mon, 12 Oct 2015) $
 * @version        $Rev: 7215 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Fetr {

    /**
     * Contructor
     *
     * @param array $procParameters
     * @return void
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('FIRT'));
        $this->batch_id = (!empty($procParameters ['BATCH_ID'])) ? $procParameters ['BATCH_ID'] : batch_id();
        $this->username = $_SESSION ['user_record'] ['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
    }

    /**
     * Initialice firt form
     * Executed on init event
     */
    function fetr_init_form(&$record) {

    }

// end function
    /**
     * Validate record information
     * Executed on table validate
     */
    function fetr_validate_form(&$record, &$msg) {
        getLookupValue('FETR_FIDU_RATETBLCODE', 'FIDU_RATETBLCODE', $record);
        $firtrec = ClxCommon::$db->getFields($this->firtname, 'STATUS, FEE_TYPE, ASSET_COM_BASE', 'IDCODE = ' . singleQuote($record ['FETR_FIDU_RATETBLCODE']));
        if ($firtrec ['FEE_TYPE'] !== 'FLAT' && !($firtrec ['FEE_TYPE'] === 'ADMN' && $firtrec ['ASSET_COM_BASE'] === 'FIAT')) {
		  $msg ['FETR_TRANSTBL_CODE'] = 'FETR02 ' . dict('GEN_ERR_INVALID_FEE_TYPE_MUSTBEFLAT');
        }
        if ($firtrec ['STATUS'] !== 'A') {
		  $msg ['FETR_FIDU_RATETBLCODE'] = 'FETR02 ' . dict('GEN_ERR_INVALID_STATUS');
        }
    }

// end function
    /**
     * Update Parent (FETR) Information one record is saved
     */
    function fetr_save_form(&$record) {
        // Update modified by and modification date on FETR
    }

}
