<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-03 12:24:19 -0400 (Thu, 03 Sep 2015) $
 * @version        $Rev: 6814 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Ltac {

    /**
     * Constructor
     * @param array [$procParameters]
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('LTAC'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->je_source = '';
    }

    /**
     * Executes Action
     */
    public function action() {
        $contents = '';
        $jm = explode(':', UserRequest::$post['jm']);
        $jmp_list_item_id = $jm[CLX_NUM_ONE];
        if (count($jm) > CLX_NUM_ONE) {
		  $ltacrec = ClxCommon::$db->getRecord($this->ltacname, 'ID = ' . singleQuote($jmp_list_item_id));
        } else {
		  $ltacrec = ClxCommon::$db->getRecord($this->ltacname, 'IDCODE = ' . singleQuote(UserRequest::$post['jm']));
        }
        if (!empty($ltacrec['CODE_TEXT'])) {
		  //Run ltacrec
		  if (!empty($ltacrec['CODE_LIBRARY'])) {
			 includeCodeLib($ltacrec['CODE_LIBRARY']);
		  }
		  include_once savePhpCodeEvents('ltac_' . $ltacrec['ID'], $ltacrec['CODE_TEXT']);
        }
        return $contents;
    }

}
