<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date:  14:20:58 -0400 (Wed, 02 Sep 2009) $
 * @version        $Rev: 1376 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Orsh {
    /* Contructor
     *
     * @param array $procParameters
     * @return void
     */

    function __construct($procParameters = array()) {
        multiTableName($this, array('ORSH', 'ORPY', 'ORDL', 'ORDR', 'PROD', 'ITEM', 'CONT'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
    }

    /**
     * Initialice figa form
     * Executed on init event
     */
    function orsh_init_form(&$record) {
        if (UserRequest::$request['ac'] === 'CREATE') {
		  $sql = 'SELECT  CONT.ADDRESS1_02 ORSH_ADDRESS1, CONT.ADDRESS2_02 ORSH_ADDRESS2, CONT.CITY_02 ORSH_CITY, CONT.STATE_02 ORSH_STATE, CONT.FOREIGN_STATE_02 ORSH_FOREIGN_STATE, CONT.ZIPCODE_02 ORSH_ZIPCODE, CONT.COUNTRY_02 ORSH_COUNTRY FROM  ORDR_ORDERS ORDR, CRM_CONTACTS CONT WHERE  CONT.IDCODE = ORDR.CONTACT_CODE AND ORDR.IDCODE =' . singleQuote($record['ORSH_ORDERCODE']);
		  $billing_address = ClxCommon::$db->getOneRecord($sql);
		  //Load client information defaults
		  foreach ($billing_address as $key => $val) {
			 $record[$key] = $val;
		  }
        }
    }

    /**
     * Validate record information
     * Executed on table validate
     */
    function orsh_validate_form(&$record, &$msg) {
        $status = true;
        return $status;
    }

    /**
     * Events associate before database commit
     */
    function orsh_save_pre_commit(&$record) {

    }

}
