
<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-03 12:24:19 -0400 (Thu, 03 Sep 2015) $
 * @version        $Rev: 6814 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Sraa {

    /**
     * Contructor
     *
     * @param array $procParameters
     * @return void
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('SRAP', 'SRAA', 'ACTI', 'PROD', 'ACCO'));
        $this->batch_id = (!empty($procParameters ['BATCH_ID'])) ? $procParameters ['BATCH_ID'] : batch_id();
        $this->username = $_SESSION ['user_record'] ['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
    }

    /**
     * Initialice fiai form
     * Executed on init event
     */
    function init_form(&$record) {
        $sql = 'SELECT IFNULL(MAX(SRAA.SEQNUM),0)+1 FROM ' . $this->sraaname . ' SRAA WHERE SRAA.SRAP_CODE =' . singleQuote($record['SRAA_SRAP_CODE']) . ' AND SRAA.CLX_EFFTDATE = ' . $record['SRAA_CLX_EFFTDATE'];
        $record['SRAA_SEQNUM'] = ClxCommon::$db->getOne($sql);
    }

// end function
    /**
     * Validate record information
     * Executed on table validate
     */
    function validate_form(&$record, &$msg) {
        $has_rol = (!empty($record['SRAA_ROLE_CODE'])) ? true : false;
        switch ($record['SRAA_ASSIGN_RULE']) {
		  case 'RO':
			 if (empty($has_rol))
			     $msg['SRAA_ROLE_CODE'] = smsg('MSG-346');
			 break;
		  case 'RL':
			 if (empty($has_rol))
			     $msg['SRAA_ROLE_CODE'] = smsg('MSG-346');
			 break;
		  default:
			 if (!empty($has_rol))
			     $msg['SRAA_ROLE_CODE'] = smsg('MSG-347');
			 break;
        }
    }

// end function
}
