<?php 
/**
* Auto generated event file. Changes will be lost.
* For more information contact  support@alenet.com
* @since        $Date: 2023-05-03 07:33:58 
*/

/*## INSLITR#1, ACTUALIZA SALDOS DE PRESTAMOS CON TRANSACCIONES DEL DIA##*/
$tablename='LOIN_INS_BALANCES';
$tablename2='LOIN_TRANSACTIONS';
//pre($record);

$sql = 'SELECT COUNT(*) FROM '.$tablename.' WHERE
SUBSYS_CODE= '. singleQuote($record['SUBSYS_CODE']) .'
AND BRANCH_NO='. singleQuote($record['BRANCH_NO']) . '
AND LOAN_NO='. singleQuote($record['LOAN_NO']) . '
AND COMP_CODE='. singleQuote($record['COMP_CODE']) . '
AND INSURANCE_TYPE='. singleQuote($record['INSURANCE_TYPE']) . ' 
AND CLX_EFFTDATE= TO_DATE('.singleQuote($parameters['EFFTDATE']) . ',' . singleQuote('YYYY-MM-DD').')' ;


//OBTENGO EL ULTIMO SALDO AL QUE LE APLICARE LA ARITMETICA JUNTO AL MONTO DE TRANSACCIÓN
$sql2 = 'SELECT BAL_AMT FROM '.$tablename.' WHERE
SUBSYS_CODE= '. singleQuote($record['SUBSYS_CODE']) .'
AND BRANCH_NO='. singleQuote($record['BRANCH_NO']) . '
AND LOAN_NO='. singleQuote($record['LOAN_NO']) . '
AND COMP_CODE='. singleQuote($record['COMP_CODE']). '
AND INSURANCE_TYPE='. singleQuote($record['INSURANCE_TYPE']) . ' 
ORDER BY CLX_EFFTDATE DESC
FETCH NEXT 1 ROWS ONLY';

$saldo = ClxCommon::$db->getOne($sql2);

//OBTENGO DESCRIPCION DE LA MONEDA SEGUN SUB-APLICACION
$moneda = 'SELECT  NVL(IDNAME,'. singleQuote('') .')  FROM CLX_DB_LIST_ITEMS WHERE
LISTCODE= '. singleQuote('CUR') .' 
AND IDCODE= '. singleQuote($record['SUBSYS_CODE']);

$id_desc = ClxCommon::$db->getOne($moneda);
$desc_moneda='';
if ($id_desc != ''){
    $desc_moneda = dict($id_desc);
}

//OBTENGO STATUS DE PRESTAMO
$sql_status = 'SELECT LOAN_STATUS FROM LOIN_LOANS WHERE
SUBSYS_CODE= '. singleQuote($record['SUBSYS_CODE']) .'
AND BRANCH_NO='. singleQuote($record['BRANCH_NO']) . '
AND LOAN_NO='. singleQuote($record['LOAN_NO']) . '
AND COMP_CODE='. singleQuote($record['COMP_CODE']);
$status = ClxCommon::$db->getOne($sql_status);


if (ClxCommon::$db->getOne($sql)==0){

//SI NO EXISTE ENTRADA DE SALDO DE PRESTAMO  ENTONCES SE AGREGA DIRECTAMENTE SIN ARITMETICA
$sql2='INSERT INTO LOIN_INS_BALANCES
(
SUBSYS_CODE,
BRANCH_NO,
LOAN_NO,
COMP_CODE,
CLX_EFFTDATE,
EFFTDATE,
INSURANCE_TYPE,
LOAN_STATUS,
BAL_AMT,
DESC_CURRENCY,
CDATE,
CREATEDBY,
MDATE,
MODIFIEDBY
 ) VALUES( '.
singleQuote($record['SUBSYS_CODE']) .
', '.singleQuote($record['BRANCH_NO']) .
', '.singleQuote($record['LOAN_NO']) .
', '.singleQuote($record['COMP_CODE']) .
', '.singleQuote($record['TRANS_DATE']) .
', '.singleQuote($record['TRANS_DATE']) .
', '.singleQuote($record['INSURANCE_TYPE']) .
', '.singleQuote($status) .
', '.singleQuote($saldo+$record['SUBTOTAL']) .
', '.singleQuote($desc_moneda) .
', CURRENT_TIMESTAMP 
, '.singleQuote($parameters['USERNAME']) .
', CURRENT_TIMESTAMP 
, '.singleQuote($parameters['USERNAME']) .
')';

echo $sql2;
ClxCommon::$db->executeQuery($sql2);

}else{

$sql4 = 'UPDATE '.$tablename.' SET DESC_CURRENCY='. singleQuote($desc_moneda) .' ,BAL_AMT=BAL_AMT + '.$record['SUBTOTAL'] .
', MDATE=CURRENT_TIMESTAMP, MODIFIEDBY= '.singleQuote($parameters['USERNAME']) .', LOAN_STATUS='. singleQuote($status) .' 
WHERE
SUBSYS_CODE= '. singleQuote($record['SUBSYS_CODE']) .'
AND BRANCH_NO='. singleQuote($record['BRANCH_NO']) . '
AND LOAN_NO='. singleQuote($record['LOAN_NO']) . '
AND COMP_CODE='. singleQuote($record['COMP_CODE']). ' 
AND INSURANCE_TYPE='. singleQuote($record['INSURANCE_TYPE']). ' 
AND CLX_EFFTDATE= TO_DATE('.singleQuote($parameters['EFFTDATE']) . ',' . singleQuote('YYYY-MM-DD').')' ;
ClxCommon::$db->executeQuery($sql4);

}

/*ACTUALIZAMOS STATUS DE LA TRANSACCION PROCESADA*/
$sql3 = 'UPDATE '.$tablename2.' SET TRANS_STATUS='. singleQuote('PROC') .
', OBSERVATION='. singleQuote('') .', MDATE=CURRENT_TIMESTAMP, MODIFIEDBY= '.singleQuote($parameters['USERNAME']) .'  
WHERE
SUBSYS_CODE= '. singleQuote($record['SUBSYS_CODE']) .'
AND BRANCH_NO='. singleQuote($record['BRANCH_NO']) . '
AND LOAN_NO='. singleQuote($record['LOAN_NO']) . '
AND COMP_CODE='. singleQuote($record['COMP_CODE']). '
AND INSURANCE_TYPE='. singleQuote($record['INSURANCE_TYPE']). '
AND TRANS_DATE= TO_DATE('.singleQuote($parameters['EFFTDATE']) . ',' . singleQuote('YYYY-MM-DD').') 
AND TRANS_STATUS='. singleQuote('PEND');

ClxCommon::$db->executeQuery($sql3);

ClxCommon::$db->executeQuery('COMMIT');