<?php

//-----------------------------------------------------------------------------
//	CONSTANTS.PHP
//
//	System Wide Constants.  Or in windows, "the ini file"
//
//	Date:		2000]5-09-16
//	Version:	5.0.0.0
//
//-----------------------------------------------------------------------------
// System Version
define("kSystemVersion", "7.0.0.0");

// System Language
/*
define("kSystemLanguage", "en");
define("kSystemLoginLanguage", "en");
*/
define("kSystemLanguage", "en");
define("kSystemLoginLanguage", "en");

//-----------------------------------------------------------------------------
//-- DATABASE PARAMETERS
//-----------------------------------------------------------------------------
// List all Databases to by used. Database types:  mysql(<V4.1) | mysqli(V4.1+) | mssql | oci(oracle V7+)
// Database URL or Oracle TNS name, usualy is "localhost", if Apache/IIS is running in the
// same machine as the MySQL Server.
// If not, is an ip address or url., The user name and password to access the Database Server
// $kDatabase[] = array('Alias', 'Driver Type', 'Host or Ip', 'Database Name', 'DB Username', 'DB Password');

$kDatabase = array();
$kDatabase[] = array('clx56dev-oxygen', 'mysqli', 'oxygen.alenet.com:3320', 'clx56dev', 'phpaccess', 'phpalenet123');
##$kDatabase[] = array('glb56mig-local', 'mysqli', 'oxygen.alenet.com', 'glb56mig_2020', 'phpaccess', 'phpalenet');

//-----------------------------------------------------------------------------
//-- DIRECTORY PARAMETERS
//-----------------------------------------------------------------------------
// The absolute path to the system.  If you are on a Windows system
// this path will be something like: "j:/Inetpub/wwwroot/clientix/".
// On a Unix/Linux system it will be something like: "/user/docs/http/"
define("kPathToWebSite", filter_input(INPUT_SERVER, 'DOCUMENT_ROOT', FILTER_SANITIZE_STRING) . "/clx56dev/");

// Directory name where the tools are stored...
//(make sure it ends with "/", usualy "tools/")
define("kPathToTools", "tools/");

// Directory name where the objects are stored...
// (make sure it ends with "/", usualy "objects/")
define("kPathToObjects", "objects/");

// Directory to save uploaded files
// (make sure it ends with "/", usualy "data/files/")
define("kPathToData", "data/files/");

// Directory to save uploaded code
// (make sure it ends with "/", usualy "data/code/")
define("kPathToCode", "data/code/");

// Directory to save uploaded templates
// (make sure it ends with "/", usualy "data/code/")
define("kPathToTemplates", "data/templates/");

// Directory to save packages
//(make sure it ends with "/", usualy "packages/")
define("kPathToPackages", "packages/");

// Directory to save skins
//(make sure it ends with "/", usualy "skins/")
define("kPathToSkins", "skins/");

// Directory to save export fiels
// (this directory should exist, make sure it ends with "/", usualy "temp/")
define("kPathToExport", "export/");

// Directory to save import fiels
// (this directory should exist, make sure it ends with "/", usualy "temp/")
define("kPathToImport", "import/");

// Directory to save temporal files
// (this directory should exist, make sure it ends with "/", usualy "temp/")
define("kPathToTemp", "temp/");

// Directory to save temporal files
// (this directory should exist, make sure it ends with "/", usualy "temp/")
define("kPathToPear", "../extlibs/php/PEAR/");

// Directory to jpgraph
// (this directory should exist, make sure it ends with "/", usualy "temp/")
define("kPathToJpgraph", "../extlibs/php/jpgraph/src/");

// Directory to save temporal files
// (this directory should exist, make sure it ends with "/", usualy "temp/")
define("kPathToSendmail", "/usr/lib/sendmail");

// PDF Forms direct acces to the pictures.
define("kDirectPathToArchive", "s://clx56dev/data/archive/");

// The name of the web site.
define("kWebSite", "http://" . filter_input(INPUT_SERVER, 'HTTP_HOST', FILTER_SANITIZE_STRING) . "/clx56dev/");

// Directory for database backups
define("kDbBackupFolder", "temp/");

//------------------------------------------------------------------------------
//-- MAIL PARAMETERS
//------------------------------------------------------------------------------
//Default Email Account
//define("kDefaultEmail", 'support@alenet.com');
define("kDefaultEmail", 'alenettest@gmail.com');

//Default SMTP Server. Default outgoing mail server
//define("kDefaultSmtp", 'alenet.com');
define("kDefaultSmtp", 'neon.attlocal.net');

//Default SMTP Server port. Default outgoing mail server port
define("kDefaultSmtpPort", '25');

//Default mailer. Options (mail, pear). If smtp requires authentication user pear
define("kDefaultMailer", 'pear');

//Default SMTP Requires autentication. Set true if requires autentication.
//Default Mailer must be pear
//define("kDefaultSmtpReqAuth", true);
define("kDefaultSmtpReqAuth", false);

//Default SMTP username. If authentication required, set username for smtp
//define("kDefaultSmtpUsername", 'support@alenet.com');
define("kDefaultSmtpUsername", '');

//Defautl SMTP password.  If authentication required, set username for smtp
//define("kDefaultSmtpPassword", 'clientix123');
define("kDefaultSmtpPassword", '');

//------------------------------------------------------------------------------
//-- OTHER PARAMETERS
//------------------------------------------------------------------------------
//Math Functions Precision (Number of decimal Places)
define("kDefaultPrecision", 28);

// Name of the default skin
define("kDefaultSkin", "clx55white");

// Set True to Remove Back Button From Browser
define("kDefaultFrameLess", false);

// Name of the company
define("kDefaultCompany", "Alenet, Inc.");


// Cookie name to store the last menu opened by the user.
// (Usualy "Clientix_MenuBar_option")
define("kSideBarCookieName", "clientix_MenuBar_option");

//Session Timeout in minutes, set to 0 for no end.
define("kSessionTimeout", "600");

//Multi Session, set to true to allow same user to open more than one session at the
//Same time or false to restrict only one session per user
define("kSessionMultiple", true);

//Defines how many logins are allowed to user before locking it.
//Set to 0 to disable user login attemps locking
define("kSessionLoginAttempts", 10);

//Defines a date for system to expire locking the application
//Set to -1 to override or expiration date yyyy-mm-dd format
//define("kSystemExpireDate", '2010-12-01');
define("kSystemExpireDate", '-1');

//This sets the maximum amount of memory in bytes that a script is allowed to allocate.
//This helps prevent scripts for eating up all available memory on a server. Sample: 8M or -1 to no limit
define("kAppMemoryLimit", "3000M");

//This defines the maximum file size for uploads. Sample: 8M
define("kAppMaxUploadSize", "400M");

//This defines the maximum post method size allowed for the application. Sample: 8M
define("kAppMaxPostSize", "400M");

//Define Application TypeZone see http://us3.php.net/manual/en/timezones.php
// for complete list.
define("kDefaultTimeZone", "America/New_York");

//PHP Error parameters
define("kPhpDisplayErrors", true);
define("kPhpLogErrors", true);
define("kPhpErrorLog", 'error_log.txt');
//error_reporting(2147483647);

//Mysql Version, current version 5+
//For mysql prior to 5.0 set 4.1, 4.0 etc
define('kMysqlVersion', '5.0');


//Develoment Platform
define("kAppDev", true);

//Ibs demostration site, user and password sent by url on login
//Should be 0 always on production enviroments
define('kDemoIbs', 0);
define("kSessionIbsLogin", 0);
//------------------------------------------------------------------------------
// C h a t
//------------------------------------------------------------------------------
// Set True to enabled chat
define("kChatEnabled", false);

// Path to chat index page.
define("kPathToChat", "./chat/index.php");

// 2017-10-12 CR
//define("kPhpCLI", "J:/PHP/php.exe");
define("kPhpCLI", "/usr/bin/php");

// Para que clx55 no de errores tipo STRICT por todos lados cuando se corre con php 5.6
// 2015-10-23
//error_reporting(E_ALL ^E_STRICT);
ini_set('error_reporting', E_ALL );
ini_set('always_populate_raw_post_data', '-1');
##restore_error_handler();