<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Included label
 */
class ui_filter_prefs extends clx_tool {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'UIFU'; // FU?  Fuck you? noooo.  FP is form panels!
        $this->name = 'Filter Preferences';
        $this->system = 'Interface';
        $this->version = '0.1.0.0';
        $this->accesskey = 'UIFT';



        $this->tablename = 'CLX_UI_FILTER_PREFS';
        $this->record_name_singular = 'filter preference';
        $this->record_name_plural = 'filter preferences';
        $this->primary_field = 'username';
        $this->secondary_field = 'querycode';
        $this->seqnum_field = 'seqnum';
    }

    function toolTableStructure() {
        $fields = array();
        $fields['ID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => 'auto_increment', 'index' => 'PRI');
        $fields['QUERYCODE'] = array('type' => 'varchar(16)', 'null' => 'YES', 'properties' => '');
        $fields['USERNAME'] = array('type' => 'varchar(30)', 'null' => 'NO', 'properties' => '');
        $fields['FILTERID'] = array('type' => 'int(11) unsigned', 'null' => 'NO', 'properties' => '', 'default' => CLX_NUM_ZERO);
        $indexes = array();
        $ipf = 'CLX' . $this->code;
        $indexes[$ipf . '01'] = array('index' => 'PRI', 'fieldname' => 'ID');
        $indexes[$ipf . '02'] = array('index' => 'MUL', 'fieldname' => 'QUERYCODE');
        $indexes[$ipf . '03'] = array('index' => 'MUL', 'fieldname' => 'USERNAME');
        $indexes[$ipf . '04'] = array('index' => 'MUL', 'fieldname' => 'FILTERID');
        return array('idcode' => $this->code, 'idname' => $this->name, 'name' => $this->tablename, 'type' => 'InnoDB', 'fields' => $fields, 'indexes' => $indexes);
    }

}
